.equ REC_LEER			= 0
.equ REC_MANUELL		= 1
.equ REC_TIMER			= 2
.equ REC_TP				= 3


.equ SD_REC_MODUS			=(adr_SD_DATA+0)  ;0=leer															
.equ SD_REC_Tag				=(adr_SD_DATA+1)
.equ SD_REC_Monat			=(adr_SD_DATA+2)
.equ SD_REC_Jahr			=(adr_SD_DATA+3)
.equ SD_REC_hh				=(adr_SD_DATA+4)
.equ SD_REC_mm				=(adr_SD_DATA+5)
.equ SD_REC_ss				=(adr_SD_DATA+6)

.equ SD_REC_SN0				=(adr_SD_DATA+7)
.equ SD_REC_SN1			=(adr_SD_DATA+8)
.equ SD_REC_SN2	=(adr_SD_DATA+9)
.equ SD_REC_SN3	=(adr_SD_DATA+10)
.equ SD_REC_SN4	=(adr_SD_DATA+11)
.equ SD_REC_SN5	=(adr_SD_DATA+12)
.equ SD_REC_SN6	=(adr_SD_DATA+13)
.equ SD_REC_SN7	=(adr_SD_DATA+14)


.equ SD_REC_STARTSEKTOR0	=(adr_SD_DATA+15)
.equ SD_REC_STARTSEKTOR1	=(adr_SD_DATA+16)
.equ SD_REC_STARTSEKTOR2	=(adr_SD_DATA+17)
.equ SD_REC_STARTSEKTOR3	=(adr_SD_DATA+18)

.equ SD_REC_ENDESEKTOR0	=(adr_SD_DATA+19)
.equ SD_REC_ENDESEKTOR1	=(adr_SD_DATA+20)
.equ SD_REC_ENDESEKTOR2	=(adr_SD_DATA+21)
.equ SD_REC_ENDESEKTOR3	=(adr_SD_DATA+22)
; ##############################################################################
; ##############################################################################
; ##############################################################################
AUDIO_ON:
	call ADC_INTERRUPT_ON
ret
; ##############################################################################
AUDIO_OFF:
	call ADC_INTERRUPT_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 207 Sektoren pro Sekunde														
AUDIO_PLAY:
	call AUDIO_OFF
	call TFT_CLEAR
	call TASTEN_PLAY_DEFINIEREN
;-------------------------------------------------------------------------------
; REC-NR laden																	
AUDIO_PLAY_RUN:
	call SEKTOR_NULL
	LDS SEKTOR0,(adr_REC_NR); REC-NR		
	call SD_SEKTOR_READ		; read !!!		
;-------------------------------------------------------------------------------
; Anzeige																		
	LDS SEKTOR0,(SD_REC_STARTSEKTOR0)	; STARTSEKTOR	
	LDS SEKTOR1,(SD_REC_STARTSEKTOR1)
	LDS SEKTOR2,(SD_REC_STARTSEKTOR2)
	LDS SEKTOR3,(SD_REC_STARTSEKTOR3)
	call AUDIO_PLAY_ANZEIGE
;-------------------------------------------------------------------------------
; NULL-CHECK																	
AUDIO_PLAY_START:
	tst SEKTOR0
	brne AUDIO_PLAY_w1
	tst SEKTOR1
	brne AUDIO_PLAY_w1
	tst SEKTOR2
	brne AUDIO_PLAY_w1
	tst SEKTOR3
	brne AUDIO_PLAY_w1
	call AUDIO_SET_SEKTOR_DATA			; Sektor auf DATA	
;-------------------------------------------------------------------------------
; OVERLOW-CHECK																	
AUDIO_PLAY_w1:	
	call SD_SEKTOR_OVERLOW_C
	brcc AUDIO_PLAY_MS
	call AUDIO_SET_SEKTOR_DATA			; Sektor auf DATA	
;-------------------------------------------------------------------------------
AUDIO_PLAY_MS:
	call SD_SEKTOR_READ_MULTIPLE_START			; START		
;-------------------------------------------------------------------------------
AUDIO_PLAY_s:
	ldi temp1,(0xFE)							; auf  0xFE warten	
	rcall SPI_WAIT_TEMP1_C
	brcs AUDIO_PLAY_512
	rjmp AUDIO_PLAY_ERROR
;-------------------------------------------------------------------------------
; 512 Bytes read																
AUDIO_PLAY_512:
	ldi ZL,LOW (512)
	ldi ZH,HIGH(512)
;-------------------------------------------------------------------------------
; Dummy ASC fr Samplingrate													
AUDIO_PLAY_WAIT:
	WDR
	LDS temp,ADCSRA								; auslesen								
	sbrs temp, ADIF								; ADC-MESSUNG, warten bis ADIF-FLAG gesetzt							
	rjmp AUDIO_PLAY_WAIT
;-------------------------------------------------------------------------------
	STS ADCSRA,temp								; ADC-START (ADIF-FLAG lschen durch logisch "1")					
;	LDS temp,ADCL								; zuerst das LOW-Byte					
	LDS temp,ADCH								; dann das HIGH BYTE	(als Dummy !)	
;-------------------------------------------------------------------------------
	rcall SPI_RX_TEMP							; OUT: temp				
	STS PWM_NF,temp								; PWM					
	rcall AUDIO_LED								; LEDs					
;-------------------------------------------------------------------------------
	sbiw ZL,1
	tst ZL
	brne AUDIO_PLAY_WAIT
	tst ZH
	brne AUDIO_PLAY_WAIT
;-------------------------------------------------------------------------------
	sbic (TFT_PIN),(TFT_PIN_NR)	; springe, wenn BIT(PIN) high
	rjmp AUDIO_PLAY_w
;-------------------------------------------------------------------------------
; Tastenauswertung																
AUDIO_PLAY_T:
	call SD_SEKTOR_READ_MULTIPLE_STOP	; STOP	
	call GRAFIC_TASTEN_ABFRAGEN
	LDS temp,(adr_TASTE)
	cpi temp,10
	breq AUDIO_PLAY_T10
	cpi temp,11
	breq AUDIO_PLAY_T11
	cpi temp,12
	breq AUDIO_PLAY_T12
	cpi temp,13
	breq AUDIO_PLAY_T13
	cpi temp,14
	breq AUDIO_PLAY_T14
	cpi temp,15
	breq AUDIO_PLAY_T15
	cpi temp,16
	breq AUDIO_PLAY_T16
	cpi temp,17
	breq AUDIO_PLAY_T17
	cpi temp,18
	breq AUDIO_PLAY_T18
	cpi temp,19
	breq AUDIO_PLAY_T19
	rjmp AUDIO_PLAY_w
;-------------------------------------------------------------------------------
AUDIO_PLAY_T10:; NR-	
	LDS temp,(adr_REC_NR)
	dec temp
	STS(adr_REC_NR),temp
	rjmp AUDIO_PLAY_RUN
AUDIO_PLAY_T11:; NR-	
	LDS temp,(adr_REC_NR)
	dec temp
	dec temp
	dec temp
	dec temp
	dec temp
	STS(adr_REC_NR),temp
	rjmp AUDIO_PLAY_RUN
AUDIO_PLAY_T12:; ESC	
	rjmp AUDIO_PLAY_EXIT
AUDIO_PLAY_T13:; NR+	
	LDS temp,(adr_REC_NR)
	inc temp
	inc temp
	inc temp
	inc temp
	inc temp
	STS(adr_REC_NR),temp
	rjmp AUDIO_PLAY_RUN
AUDIO_PLAY_T14:; NR+	
	LDS temp,(adr_REC_NR)
	inc temp
	STS(adr_REC_NR),temp
	rjmp AUDIO_PLAY_RUN
AUDIO_PLAY_T15:;Sektor-	
	call AUDIO_PLAY_ZURUCK
	call AUDIO_PLAY_ZURUCK
	call AUDIO_PLAY_ZURUCK
	call AUDIO_PLAY_ANZEIGE
	rjmp AUDIO_PLAY_START
AUDIO_PLAY_T16:;Sektor-	
	call AUDIO_PLAY_ZURUCK
	call AUDIO_PLAY_ANZEIGE
	rjmp AUDIO_PLAY_START
AUDIO_PLAY_T17:; STOP	
	call AUDIO_PLAY_ANZEIGE
AUDIO_PLAY_T17s:
	WDR
	sbic (TFT_PIN),(TFT_PIN_NR)	; springe, wenn BIT(PIN) high
	rjmp AUDIO_PLAY_T17s
	call GRAFIC_TASTEN_ABFRAGEN
	call AUDIO_PLAY_ANZEIGE
	rjmp AUDIO_PLAY_START
AUDIO_PLAY_T18:; Sektor+	
	call AUDIO_PLAY_VOR
	call AUDIO_PLAY_ANZEIGE
	rjmp AUDIO_PLAY_START
AUDIO_PLAY_T19:; Sektor+	
	call AUDIO_PLAY_VOR
	call AUDIO_PLAY_VOR
	call AUDIO_PLAY_VOR
	call AUDIO_PLAY_ANZEIGE
	rjmp AUDIO_PLAY_START
;-------------------------------------------------------------------------------
AUDIO_PLAY_w:
	call SEKTOR_PLUS_EINS
	call SD_SEKTOR_OVERLOW_C
	brcs AUDIO_PLAY_OVERLOW

	call SEKTOR_NACH_TEMP1_4
	LDS temp5,(SD_REC_ENDESEKTOR0)		; ENDESEKTOR	
	LDS temp6,(SD_REC_ENDESEKTOR1)
	LDS temp7,(SD_REC_ENDESEKTOR2)
	LDS temp8,(SD_REC_ENDESEKTOR3)
	cp temp1,temp5
	brne AUDIO_PLAY_w2
	cp temp2,temp6
	brne AUDIO_PLAY_w2
	cp temp3,temp7
	brne AUDIO_PLAY_w2
	cp temp4,temp8
	brne AUDIO_PLAY_w2
	call BEEP
	call SD_SEKTOR_READ_MULTIPLE_STOP	; STOP	
	LDS temp,(adr_REC_NR)				; REC-NR		
	inc temp
	STS(adr_REC_NR),temp
	jmp AUDIO_PLAY_RUN
;-------------------------------------------------------------------------------
AUDIO_PLAY_w2:



	rjmp AUDIO_PLAY_s
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
AUDIO_PLAY_OVERLOW:
	call SD_SEKTOR_READ_MULTIPLE_STOP			; STOP		
	BEEP_AN
	call TFT_CLEAR
	call TEXT_SD
	call TEXT_OVERLOW
	call WAIT_2s
	BEEP_AUS
	rjmp AUDIO_PLAY_EXIT
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
AUDIO_PLAY_EXIT:
	call AUDIO_ON
	call TFT_CLEAR
ret
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
AUDIO_PLAY_ERROR:
	BEEP_AN
	call WAIT_5s
	call SD_SEKTOR_READ_MULTIPLE_STOP			; STOP		
	call AUDIO_ON
	call TFT_CLEAR
	call TEXT_ERROR
	call WAIT_1s
	BEEP_AUS
ret
;-------------------------------------------------------------------------------
AUDIO_PLAY_VOR:
.equ STEP=207*60*1 ; 1 Minute
	ldi temp1,BYTE1(STEP)
	ldi temp2,BYTE2(STEP)
	ldi temp3,BYTE3(STEP)
	ldi temp4,BYTE4(STEP)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,temp3
	adc SEKTOR3,temp4
	ret
;-------------------------------------------------------------------------------
AUDIO_PLAY_ZURUCK:
	ldi temp1,BYTE1(-STEP)
	ldi temp2,BYTE2(-STEP)
	ldi temp3,BYTE3(-STEP)
	ldi temp4,BYTE4(-STEP)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,temp3
	adc SEKTOR3,temp4
	tst SEKTOR3		; negativ ?
	brmi AUDIO_PLAY_ZURUCK_u
	ret
AUDIO_PLAY_ZURUCK_u:
	call SEKTOR_NULL
	ret
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
AUDIO_PLAY_ANZEIGE:
	call TFT_TEXT_CLEAR
	call ZEILE1
	LDS temp1,(SD_REC_Tag)	; Zeitstempel
	call ZAHL2_temp1
	call ASCII_PUNKT
	LDS temp1,(SD_REC_Monat)
	call ZAHL2_temp1
	call ASCII_PUNKT
	LDS temp1,(SD_REC_Jahr)
	call ZAHL2_temp1
	call ASCII_SPACE4
	LDS temp1,(SD_REC_hh)	; Zeitstempel
	call ZAHL2_temp1
	call ASCII_DOPPELPUNKT
	LDS temp1,(SD_REC_mm)
	call ZAHL2_temp1
	call ASCII_DOPPELPUNKT
	LDS temp1,(SD_REC_ss)
	call ZAHL2_temp1
;-------------------------------------------------------------------------------
	call ZEILE2
	LDS temp,(SD_REC_SN0)	; Sendername	
	call PAKET_DATA_TEMP
	LDS temp,(SD_REC_SN1)
	call PAKET_DATA_TEMP
	LDS temp,(SD_REC_SN2)
	call PAKET_DATA_TEMP
	LDS temp,(SD_REC_SN3)
	call PAKET_DATA_TEMP
	LDS temp,(SD_REC_SN4)
	call PAKET_DATA_TEMP
	LDS temp,(SD_REC_SN5)
	call PAKET_DATA_TEMP
	LDS temp,(SD_REC_SN6)
	call PAKET_DATA_TEMP
	LDS temp,(SD_REC_SN7)
	call PAKET_DATA_TEMP
;-------------------------------------------------------------------------------
	call ZEILE3
	LDS temp1,(adr_REC_NR)	; REC-NR	
	call ZAHL_TEMP1
	LDS temp,(SD_REC_MODUS)	; REC-Modus		
	call ANZEIGE_REC_MODUS_TEMP
	call ASCII_SPACE
	LDS temp1,(SD_REC_ENDESEKTOR0)	; Rec-Zeit
	LDS temp2,(SD_REC_ENDESEKTOR1)
	LDS temp3,(SD_REC_ENDESEKTOR2)
	LDS temp4,(SD_REC_ENDESEKTOR3)
	LDS temp5,(SD_REC_STARTSEKTOR0)
	LDS temp6,(SD_REC_STARTSEKTOR1)
	LDS temp7,(SD_REC_STARTSEKTOR2)
	LDS temp8,(SD_REC_STARTSEKTOR3)
	sub temp1,temp5
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8
	call ANZEIGE_REC_ZEIT_TEMP1_2_3_4
;-------------------------------------------------------------------------------
	call ZEILE4
	call ASCII_SPACE6
	call ASCII_SPACE6
	call SEKTOR_NACH_TEMP1_4
	LDS temp5,(SD_REC_STARTSEKTOR0)
	LDS temp6,(SD_REC_STARTSEKTOR1)
	LDS temp7,(SD_REC_STARTSEKTOR2)
	LDS temp8,(SD_REC_STARTSEKTOR3)
	sub temp1,temp5
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8
	call ANZEIGE_REC_ZEIT_TEMP1_2_3_4
;-------------------------------------------------------------------------------
	call ZEILE5
	LDS temp1,(SD_REC_STARTSEKTOR0)	; STARTSEKTOR	
	LDS temp2,(SD_REC_STARTSEKTOR1)
	LDS temp3,(SD_REC_STARTSEKTOR2)
	LDS temp4,(SD_REC_STARTSEKTOR3)
	call ZAHL_TEMP1_2_3_4
;-------------------------------------------------------------------------------
	call ZEILE6
	LDS temp1,(SD_REC_ENDESEKTOR0)		; ENDESEKTOR	
	LDS temp2,(SD_REC_ENDESEKTOR1)
	LDS temp3,(SD_REC_ENDESEKTOR2)
	LDS temp4,(SD_REC_ENDESEKTOR3)
	call ZAHL_TEMP1_2_3_4
;-------------------------------------------------------------------------------
	call ZEILE7
	call ANZEIGE_SEKTOR_DEZ_KURZ
;-------------------------------------------------------------------------------
	jmp PAKET_SENDEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
AUDIO_REC:
	LED_GELB_AN
	LED_GRUEN_AN
	LED_ROT_AUS
	STS(adr_REC_NR),NULL
	call TFT_CLEAR
	call AUDIO_OFF
;-------------------------------------------------------------------------------
; REC-NR suchen																	
REC_RUN:
	LDS SEKTOR0,(adr_REC_NR)	; REC.NR		
	clr SEKTOR1
	clr SEKTOR2
	clr SEKTOR3
	call SD_SEKTOR_READ			; Datensatz read
;-------------------------------------------------------------------------------
; REC-NR untersuchen															
	LDS temp,(SD_REC_MODUS)
	cpi temp,(REC_LEER)					;
	breq REC_FOUND
	LDS temp,(adr_REC_NR)	
	inc temp
	STS(adr_REC_NR),temp	
	cpi temp,0
	breq REC_FOUND				; kein Datensatz gefunden	
	rjmp REC_RUN				; Next Datensaatz			
;-------------------------------------------------------------------------------
; REC-NR ist festgelegt															
REC_FOUND:
	LDS SEKTOR0,(adr_REC_NR)		; REC.NR		
	clr SEKTOR1
	clr SEKTOR2
	clr SEKTOR3
	call SD_SEKTOR_READ				; Datensatz read
	LDS temp1,(SD_REC_STARTSEKTOR0)	; Startsektor	
	LDS temp2,(SD_REC_STARTSEKTOR1)
	LDS temp3,(SD_REC_STARTSEKTOR2)
	LDS temp4,(SD_REC_STARTSEKTOR3)
	tst temp1
	brne REC_NO_NULL
	tst temp2
	brne REC_NO_NULL
	tst temp3
	brne REC_NO_NULL
	tst temp4
	brne REC_NO_NULL
	ldi temp1,BYTE1(REC_DATA)
	ldi temp2,BYTE2(REC_DATA)
	ldi temp3,BYTE3(REC_DATA)
	ldi temp4,BYTE4(REC_DATA)
;-------------------------------------------------------------------------------
REC_NO_NULL:
	STS(adr_REC_STARTSEKTOR0),temp1	; Startsektor	
	STS(adr_REC_STARTSEKTOR1),temp2
	STS(adr_REC_STARTSEKTOR2),temp3
	STS(adr_REC_STARTSEKTOR3),temp4
;-------------------------------------------------------------------------------
; Datensatz write																
	call SD_DATA_CLEAR
	LDS temp,(adr_REC_MODUS)
	STS(SD_REC_MODUS),temp
	LDS temp,(adr_TAG)
	STS(SD_REC_Tag),temp
	LDS temp,(adr_MONAT)
	STS(SD_REC_Monat),temp
	LDS temp,(adr_JAHR)
	STS(SD_REC_Jahr),temp
	LDS temp,(adr_hh)
	STS(SD_REC_hh),temp
	LDS temp,(adr_mm)
	STS(SD_REC_mm),temp
	LDS temp,(adr_ss)
	STS(SD_REC_ss),temp

	LDS temp,(adr_SENDERNAME8+0)
	STS(SD_REC_SN0),temp
	LDS temp,(adr_SENDERNAME8+1)
	STS(SD_REC_SN1),temp
	LDS temp,(adr_SENDERNAME8+2)
	STS(SD_REC_SN2),temp
	LDS temp,(adr_SENDERNAME8+3)
	STS(SD_REC_SN3),temp
	LDS temp,(adr_SENDERNAME8+4)
	STS(SD_REC_SN4),temp
	LDS temp,(adr_SENDERNAME8+5)
	STS(SD_REC_SN5),temp
	LDS temp,(adr_SENDERNAME8+6)
	STS(SD_REC_SN6),temp
	LDS temp,(adr_SENDERNAME8+7)
	STS(SD_REC_SN7),temp

	LDS temp1,(adr_REC_STARTSEKTOR0)
	LDS temp2,(adr_REC_STARTSEKTOR1)
	LDS temp3,(adr_REC_STARTSEKTOR2)
	LDS temp4,(adr_REC_STARTSEKTOR3)
	STS(SD_REC_STARTSEKTOR0),temp1
	STS(SD_REC_STARTSEKTOR1),temp2
	STS(SD_REC_STARTSEKTOR2),temp3
	STS(SD_REC_STARTSEKTOR3),temp4
	call SD_SEKTOR_WRITE			; WRITE
;-------------------------------------------------------------------------------
; Anzeige																		
	call TFT_CLEAR
	call TASTE_RECORD_DEFINIEREN
	call ZEILE12
	LDS SEKTOR0,(adr_REC_STARTSEKTOR0)
	LDS SEKTOR1,(adr_REC_STARTSEKTOR1)
	LDS SEKTOR2,(adr_REC_STARTSEKTOR2)
	LDS SEKTOR3,(adr_REC_STARTSEKTOR3)
	call SEKTOR_NACH_TEMP1_4		; ANzeige
	call ZAHL_TEMP1_2_3_4
	call ZEILE13
	LDS temp1,(adr_REC_NR)
	call ZAHL_TEMP1
	LDS temp1,(adr_TIMER_REC)
	call ZAHL_TEMP1


	call SEKTOR_NACH_TEMP1_4
	call ANZEIGE_REC_ZEIT_TEMP1_2_3_4
	call PAKET_SENDEN
;-------------------------------------------------------------------------------
	call SD_SEKTOR_OVERLOW_C
	brcc REC_w
	call AUDIO_SET_SEKTOR_DATA			; Sektor auf DATA	
REC_w:
	call SD_SEKTOR_WRITE_MULTIPLE_START	; START !!!			
	tst ERROR
	breq REC_BLOCK
	rjmp REC_ERROR
;-------------------------------------------------------------------------------
REC_BLOCK:
	ldi temp,0b11111100				; Start Block Token senden		
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP					
	ldi ZL,LOW (512)				; 512 Bytes senden				
	ldi ZH,HIGH(512)
;-------------------------------------------------------------------------------
REC_512:
	LDS temp,ADCSRA								; auslesen					
	sbrs temp, ADIF								; ADC-MESSUNG, warten bis ADIF-FLAG gesetzt							
	rjmp REC_512
;-------------------------------------------------------------------------------
	STS ADCSRA,temp								; ADC-START (ADIF-FLAG lschen durch logisch "1")					
;	LDS temp,ADCL								; zuerst das LOW-Byte	
	LDS temp,ADCH								; dann das HIGH BYTE	
	STS PWM_NF,temp								; PWM					
;-------------------------------------------------------------------------------
	rcall SPI_TX_RX_TEMP						; INP/OUT: TEMP			
	sbiw ZL,1
	tst ZL
	brne REC_512
	tst ZH
	brne REC_512
;-------------------------------------------------------------------------------
	LED_ROT_AN
	ldi temp1,(0xE5)							; auf  0xE5 warten	
	rcall SPI_WAIT_TEMP1_C
	brcc REC_ERROR								; ERROR				
	ldi temp1,(0xFF)							; auf  0xFF warten	
	rcall SPI_WAIT_TEMP1_C
	brcc REC_ERROR								; ERROR				
	LED_ROT_AUS

	call SEKTOR_PLUS_EINS
	call SD_SEKTOR_OVERLOW_C
	brcs REC_OVERLOW
	LDS temp,(adr_TIMER_REC)					; TIMER abelaufen ?
	tst temp
	breq REC_EXIT
;-------------------------------------------------------------------------------
	sbic (TFT_PIN),(TFT_PIN_NR)					; springe, wenn BIT(PIN) low
	rjmp REC_BLOCK
	rjmp REC_EXIT
;-------------------------------------------------------------------------------
; ERROR																			
REC_ERROR:
	BEEP_AN
	call TFT_CLEAR
	call TEXT_ERROR
	call ZEILE4
	call ANZEIGE_SEKTOR_HEX_KURZ
	call WAIT_1s
	BEEP_AUS
	call SD_INITIALISIERUNG
ret
;-------------------------------------------------------------------------------
; ERROR																			
REC_OVERLOW:
	BEEP_AN
	call SD_SEKTOR_WRITE_MULTIPLE_STOP				; STOP !!!
	call TFT_CLEAR
	call TEXT_SD
	call TEXT_VOLL
	call WAIT_2s
	BEEP_AUS
	call AUDIO_SD_FORMAT
	ret
;-------------------------------------------------------------------------------
REC_EXIT:
	call SD_SEKTOR_WRITE_MULTIPLE_STOP				; STOP !!!
	STS(adr_REC_ENDESEKTOR0),SEKTOR0
	STS(adr_REC_ENDESEKTOR1),SEKTOR1
	STS(adr_REC_ENDESEKTOR2),SEKTOR2
	STS(adr_REC_ENDESEKTOR3),SEKTOR3

	LDS SEKTOR0,(adr_REC_NR)	
	clr SEKTOR1
	clr SEKTOR2
	clr SEKTOR3
	call SD_SEKTOR_READ			; READ

	LDS temp1,(adr_REC_ENDESEKTOR0)
	LDS temp2,(adr_REC_ENDESEKTOR1)
	LDS temp3,(adr_REC_ENDESEKTOR2)
	LDS temp4,(adr_REC_ENDESEKTOR3)
	STS(SD_REC_ENDESEKTOR0),temp1
	STS(SD_REC_ENDESEKTOR1),temp2
	STS(SD_REC_ENDESEKTOR2),temp3
	STS(SD_REC_ENDESEKTOR3),temp4
	call SD_SEKTOR_WRITE		; write
;-------------------------------------------------------------------------------
	LDS SEKTOR0,(adr_REC_NR)	; Next DATENSATZ
	inc SEKTOR0
	clr SEKTOR1
	clr SEKTOR2
	clr SEKTOR3
	call SD_DATA_CLEAR
	LDS temp1,(adr_REC_ENDESEKTOR0)
	LDS temp2,(adr_REC_ENDESEKTOR1)
	LDS temp3,(adr_REC_ENDESEKTOR2)
	call TEMP1_2_3_4_PLUS_EINS
	LDS temp4,(adr_REC_ENDESEKTOR3)
	STS(SD_REC_STARTSEKTOR0),temp1
	STS(SD_REC_STARTSEKTOR1),temp2
	STS(SD_REC_STARTSEKTOR2),temp3
	STS(SD_REC_STARTSEKTOR3),temp4
	call SD_SEKTOR_WRITE		; write
;-------------------------------------------------------------------------------
	call TFT_CLEAR
	call AUDIO_ON
	LED_GELB_AUS
	LED_GRUEN_AUS
	LED_ROT_AUS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
AUDIO_SET_SEKTOR_DATA:
.equ REC_DATA=1000
	ldi temp1,BYTE1(REC_DATA)
	ldi temp2,BYTE2(REC_DATA)
	ldi temp3,BYTE3(REC_DATA)
	ldi temp4,BYTE4(REC_DATA)
	jmp TEMP1_4_NACH_SEKTOR
; ##############################################################################
; ##############################################################################
; ##############################################################################
AUDIO_LED:
	LDS temp1,(PWM_NF)
	cpi temp1,127-15
	brlo AUDIO_LED_g
	cpi temp1,127+15
	brsh  AUDIO_LED_g
	LED_GELB_AUS
	STS PWM_ZEIG,NULL
	rjmp AUDIO_LED_w
AUDIO_LED_g:
	LED_GELB_AN
;-------------------------------------------------------------------------------
AUDIO_LED_w:
	cpi temp1,0
	breq AUDIO_LED_E
	cpi temp1,255
	breq AUDIO_LED_E
	LED_ROT_AUS
	ret
AUDIO_LED_E:
	LED_ROT_AN
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
AUDIO_SD_FORMAT:
	call TFT_CLEAR
	call TEXT_SD
	call TEXT_FORMAT
	call SEKTOR_NULL		; NULL
	call SD_DATA_CLEAR
	LED_GELB_AN
	ldi ZL,low (1000)
	ldi ZH,HIGH(1000)
;-------------------------------------------------------------------------------
AUDIO_SD_FORMAT_s:
	push ZL
	push ZH
	call SD_SEKTOR_WRITE
	call SEKTOR_PLUS_EINS
	tst SEKTOR0
	brne AUDIO_SD_FORMAT_w
	call ZEILE5
	call SEKTOR_NACH_TEMP1_4
	call ZAHL_TEMP1_2_3_4
	call PAKET_SENDEN
AUDIO_SD_FORMAT_w:
	pop ZH
	pop ZL
	tst ERROR
	brne AUDIO_SD_FORMAT_ERROR
	sbiw Zl,1
	tst ZL
	brne AUDIO_SD_FORMAT_s
	tst ZH
	brne AUDIO_SD_FORMAT_s
	LED_GELB_AUS
	ret
;-------------------------------------------------------------------------------
AUDIO_SD_FORMAT_ERROR:
	LED_ROT_AN
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Sgezahn																		
AUDIO_SAEGEZAHN:
	LED_GELB_AN
	call AUDIO_OFF
	call TEXT_TEST
;-------------------------------------------------------------------------------
AUDIO_SAEGE_s:
	WDR
	sbis (TFT_PIN),(TFT_PIN_NR)	; springe, wenn BIT(PIN) high
	rjmp AUDIO_SAEGE_FERTIG
;-------------------------------------------------------------------------------
	call WAIT_2us
	tst temp9		; Richtung	
	brmi AUDIO_SAEGE_n
	inc temp1
	STS PWM_NF,temp1							; PWM					
	STS PWM_ZEIG,temp1							; PWM					
	cpi temp1,255
	brne AUDIO_SAEGE_s
	com temp9		; Richtung	
	rjmp AUDIO_SAEGE_s
;-------------------------------------------------------------------------------
AUDIO_SAEGE_n:
	dec temp1
	STS PWM_NF,temp1							; PWM					
	STS PWM_ZEIG,temp1							; PWM					
	tst temp1
	brne AUDIO_SAEGE_s
	com temp9		; Richtung	
	rjmp AUDIO_SAEGE_s
;-------------------------------------------------------------------------------
AUDIO_SAEGE_FERTIG:
	LED_GELB_AUS
	call AUDIO_ON
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

