; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 02/2018																
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	temp (DATEN)														
;																				
EEPROM_READ_PLUS_Z_TEMP:
	WDR
	sbic EECR,EEPE	; Wait for completion of previous write
	rjmp EEPROM_READ_PLUS_Z_TEMP
	out EEARH, ZH	; ADRESSE						
	out EEARL, ZL
	sbi EECR,EERE	; Start eeprom read 			
	in temp,EEDR 	; Read data 					
	adiw ZL,1		; ADRESSE +1 					
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 02/2018																
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; 		 	TEMP  DATEN															
;																				
EEPROM_WRITE_PLUS_Z_TEMP:
	WDR
	sbic EECR,EEPE	; Wait for completion of previous write
	rjmp EEPROM_WRITE_PLUS_Z_TEMP
	out EEARH, ZH	; Adresse								
	out EEARL, ZL	
;-------------------------------------------------------------------------------
	sbi EECR,EERE	; Start eeprom read 			
	in R0,EEDR 		; Read data 					
	adiw ZL,1		; ADRESSE +1 					
	cp temp,R0		; vergleich (muss temp wirklich geschrieben werden?)	
	brne EEPROM_WRITE_RUN
	ret
;-------------------------------------------------------------------------------
EEPROM_WRITE_RUN:
	WDR
	BEEP_AN
	LED_GELB_AN
	out EEDR,temp	; Write data							
	sbi EECR,EEMPE	; Write logical one to EEMPE			
	sbi EECR,EEPE 	; Start eeprom write by setting EEPE	
	call WAIT_20ms
	LED_GELB_AUS
	BEEP_AUS
	call WAIT_20ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_SAVE:
.equ ANZAHL_EEPROM_BYTES=400

	call TFT_CLEAR
	call TEXT_SAVE
	call WAIT_200ms
	ldi YL, LOW(adr_DATEN)				; DATEN		
	ldi YH,HIGH(adr_DATEN)
	clr ZL								; Z-ADRESSE	
	clr ZH
;-------------------------------------------------------------------------------
EEPROM_SAVE_s:
	LD temp,Y+
	rcall EEPROM_WRITE_PLUS_Z_TEMP
	cpi ZL,LOW(ANZAHL_EEPROM_BYTES)		; Schleife	
	brne EEPROM_SAVE_s
	cpi ZH,HIGH(ANZAHL_EEPROM_BYTES)	; Schleife	
	brne EEPROM_SAVE_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_LOAD:
	clr ZL								; Z-ADRESSE	
	clr ZH
	rcall EEPROM_READ_PLUS_Z_TEMP
	cpi temp,(VERSION)
	breq EEPROM_LOAD_RUN
;-------------------------------------------------------------------------------
	call ZEILE1
	call TEXT_EEPROM
	call TEXT_WERK
	call WAIT_1s
	ret
;-------------------------------------------------------------------------------
EEPROM_LOAD_RUN:
	ldi YL,LOW (adr_DATEN)				; DATEN		
	ldi YH,HIGH(adr_DATEN)
	clr ZL								; Z-ADRESSE	
	clr ZH
EEPROM_LOAD_RUN_s:
	rcall EEPROM_READ_PLUS_Z_TEMP
	ST Y+,temp
	cpi ZL,LOW(ANZAHL_EEPROM_BYTES)		; Schleife	
	brne EEPROM_LOAD_RUN_s
	cpi ZH,HIGH(ANZAHL_EEPROM_BYTES)	; Schleife	
	brne EEPROM_LOAD_RUN_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
