; Rev. 1.0 4/08 Table 14. Si473x Command												
.equ POWER_UP			= 0x01 ; Power up device and mode selection. 			
.equ GET_REV			= 0x10 ;  Returns revision information on the device.	
.equ POWER_DOWN			= 0x11 ;  Power down device.							
.equ SET_PROPERTY		= 0x12 ;  Sets the value of a property.					
.equ GET_PROPERTY		= 0x13 ;  Retrieves a propertys value.					
.equ GET_INT_STATUS		= 0x14 ;  Read interrupt status bits.					
.equ PATCH_ARGS			= 0x15 ;  Reserved command used for firmware file downloads.
.equ PATCH_DATA			= 0x16 ;  Reserved command used for firmware file downloads.
.equ FM_TUNE_FREQ		= 0x20 ;  Selects the FM tuning frequency.				
.equ FM_SEEK_START		= 0x21 ;  Begins searching for a valid frequency		
.equ FM_TUNE_STATUS		= 0x22 ;  Queries the status of previous FM_TUNE_FREQ or FM_SEEK_START command.
.equ FM_RSQ_STATUS		= 0x23 ;  Queries the status of the Received Signal Quality (RSQ) of the current channel (Si4735 only).
.equ FM_RDS_STATUS		= 0x24 ;  Returns RDS information for current channel and reads an entry from theRDS FIFO (Si4735 only).
.equ AM_TUNE_FREQ		= 0x40 ;  Tunes to a given AM or SW/LW frequency.		
.equ AM_SEEK_START		= 0x41 ;  Begins searching for a valid AM or SW/LW frequency depending on the AM_SEEK_BAND_BOTTOM and AM_SEEK_BAND_TOP settings.
.equ AM_TUNE_STATUS		= 0x42 ;  Queries the status of the already issued AM_TUNE_FREQ or AM_SEEK_START command.
.equ AM_RSQ_STATUS		= 0x43 ;  Queries the status of the RSQ for the current channel.
.equ GPO_CTL			= 0x80 ;  Configures GPO pins.							
.equ GPO_SET			= 0x81 ;  Sets the value of the GPO pins.				

; Rev. 1.0 4/08 Table 15. Si473x Property												
.equ GPO_IEN						= 0x0001 ; Enables interrupt sources. 0x0000
.equ DIGITAL_OUTPUT_FORMAT			= 0x0102 ; Configures the digital output format (Si4735 only). 0x0000
.equ DIGITAL_OUTPUT_SAMPLE_RATE		= 0x0104 ; Configures the digital output sample rate in 100 Hz steps. The digital output sample rate is disabled by default (Si4735 only). 0x0000
.equ REFCLK_FREQ 					= 0x0201 ; Sets frequency of reference clock in Hz. The range is 31130 to 34406 Hz, or 0 to disable the AFC. Default is 32768 Hz. 0x8000
.equ REFCLK_PRESCALE				= 0x0202 ; Sets the prescaler value for RCLK input. 0x0001
.equ FM_DEEMPHASIS					= 0x1100 ; Sets de-emphasis time constant. Default is 75 us. 0x0002
.equ FM_BLEND_STEREO_THRESHOLD 		= 0x1105 ; Sets RSSI threshold for stereo blend (full stereo above threshold,blend below threshold). To force stereo set this to 0. To force mono set this to 127. Default value is 49 dBuV. 0x0031
.equ FM_BLEND_MONO_THRESHOLD		= 0x1106 ; Sets RSSI threshold for mono blend (full mono below threshold, blend above threshold). To force stereo set this to 0. To force mono set this to 127. Default value is 30 dBuV.0x001E 
.equ FM_MAX_TUNE_ERROR 				= 0x1108 ; Sets the maximum freq error allowed before setting the AFC rail (AFCRL) indicator. Default value is 30 kHz. 0x001E 
.equ FM_RSQ_INT_SOURCE 				= 0x1200 ; Configures interrupt related to RSQ metrics. 0x0000
.equ FM_RSQ_SNR_HI_THRESHOLD		= 0x1201 ; Sets high threshold for SNR interrupt. 0x007F
.equ FM_RSQ_SNR_LO_THRESHOLD		= 0x1202 ; Sets low threshold for SNR interrupt. 0x0000
.equ FM_RSQ_RSSI_HI_THRESHOLD		= 0x1203 ; Sets high threshold for RSSI interrupt. 0x007F
.equ FM_RSQ_RSSI_LO_THRESHOLD		= 0x1204 ; Sets low threshold for RSSI interrupt. 0x0000
.equ FM_RSQ_BLEND_THRESHOLD			= 0x1207 ; Sets the blend threshold for blend interrupt when boundary is crossed. 0x0081 
.equ FM_SOFT_MUTE_MAX_ATTENUATION	= 0x1302 ; Sets maximum attenuation during soft mute (dB). Set to 0 to disable soft mute. Default is 16 dB. 0x0010
.equ FM_SOFT_MUTE_SNR_THRESHOLD 	= 0x1303 ; Sets SNR threshold to engage soft mute. Default is 4 dB. 0x0004
.equ FM_SEEK_BAND_BOTTOM			= 0x1400 ; Sets the bottom of the FM band for seek. Default is 8750. 0x222E
.equ FM_SEEK_BAND_TOP 				= 0x1401 ; Sets the top of the FM band for seek. Default is 10790. 0x2A26
.equ FM_SEEK_FREQ_SPACING			= 0x1402 ; Selects frequency spacing for FM seek. 0x000A
.equ FM_SEEK_TUNE_SNR_THRESHOLD		= 0x1403 ; Sets the SNR threshold for a valid FM Seek/Tune. Default value is 3 dB. 0x0003
.equ FM_SEEK_TUNE_RSSI_THRESHOLD	= 0x1404 ; Sets the RSSI threshold for a valid FM Seek/Tune. Default value is 20 dBuV. 0x0014
.equ FM_RDS_INT_SOURCE				= 0x1500 ; Configures RDS interrupt behavior. 0x0000
.equ FM_RDS_INT_FIFO_COUNT			= 0x1501 ; Sets the minimum number of RDS groups stored in the receive RDS FIFO required before RDS RECV is set. 0x0000
.equ FM_RDS_CONFIG 					= 0x1502 ; Configures RDS setting. 0x0000
.equ FM_BLEND_RSSI_STEREO_THRESHOLD	= 0x1800 ; Sets RSSI threshold for stereo blend. (Full stereo above threshold, blend below threshold.) To force stereo, set this to 0. To force mono, set this to 127. Default value is 49 dBV. (0x0031)
.equ FM_BLEND_RSSI_MONO_THRESHOLD   = 0x1801 ; Sets RSSI threshold for mono blend (Full mono below threshold, blend above threshold). To force stereo, set this to 0. To force mono, set this to 127. Default value is 30 dBV. (0x001E)

.equ FM_BLEND_RSSI_ATTACK_RATE		= 0x1802
.equ FM_BLEND_RSSI_RELEASE_RATE		= 0x1803
.equ FM_BLEND_SNR_STEREO_THRESHOLD  = 0x1804
.equ FM_BLEND_SNR_MONO_THRESHOLD	= 0x1805
.equ FM_BLEND_SNR_ATTACK_RATE		= 0x1806
.equ FM_BLEND_SNR_RELEASE_RATE		= 0x1807
.equ FM_BLEND_MULTIPATH_STEREO_THRESHOLD= 0x1808

.equ AM_DEEMPHASIS 					= 0x3100 ; Sets de-emphasis time constant. Can be set to 50 us. Deemphasis is disabled by default. 0x0000
.equ AM_CHANNEL_FILTER				= 0x3102 ; Selects the bandwidth of the channel filter for AM/SW/LW reception. The choices are 6, 4, 3, 2, or 1 (kHz). The default bandwidth is 2 kHz. 0x0003
.equ AM_RSQ_INTERRUPTS				= 0x3200 ; Configures interrupt related to RSQ metrics. All interrupts are disabled by default. 0x0000
.equ AM_RSQ_SNR_HIGH_THRESHOLD		= 0x3201 ; Sets high threshold for SNR interrupt. The default is 0 dB. 0x007F
.equ AM_RSQ_SNR_LOW_THRESHOLD		= 0x3202 ; Sets low threshold for SNR interrupt. The default is 0 dB. 0x0000	
.equ AM_RSQ_RSSI_HIGH_THRESHOLD		= 0x3203 ; Sets high threshold for RSSI interrupt. The default is 0 dB. 0x007F
.equ AM_RSQ_RSSI_LOW_THRESHOLD		= 0x3204 ; Sets low threshold for RSSI interrupt. The default is 0 dB. 0x0000	
.equ AM_SOFT_MUTE_RATE				= 0x3300 ; Sets the rate of attack when entering or leaving soft mute. The default is 278 dB/s. 0x0040
.equ AM_SOFT_MUTE_SLOPE				= 0x3301 ; Sets the AM/SW/LW soft mute slope. The bigger the number, the higher the max attenuation level. Default value is a slope of 2.0x0002
.equ AM_SOFT_MUTE_MAX_ATTENUATION	= 0x3302 ; Sets maximum attenuation during soft mute (dB). Set to 0 to disable soft mute. Default is 16 dB. 0x0010 
.equ AM_SOFT_MUTE_SNR_THRESHOLD		= 0x3303 ; Sets SNR threshold to engage soft mute. Default is 10 dB. 0x000A		
.equ AM_SEEK_BAND_BOTTOM			= 0x3400 ; Sets the bottom of the AM/SW/LW band for seek. Default is 520. 0x0208	
.equ AM_SEEK_BAND_TOP				= 0x3401 ; Sets the top of the AM/SW/LW band for seek. Default is 1720. 0x06AE	
.equ AM_SEEK_FREQ_SPACING			= 0x3402 ; Selects frequency spacing for AM/SW/LW seek. Default is 10 kHz spacing. 0x000A
.equ AM_SEEK_SNR_THRESHOLD			= 0x3403 ; Sets the SNR threshold for a valid AM/SW/LW Seek/Tune. If the value is zero then SNR threshold is not considered when doing a seek. Default value is 5 dB. 0x0005
.equ AM_SEEK_RSSI_THRESHOLD			= 0x3404 ; Sets the RSSI threshold for a valid AM/SW/LW Seek/Tune. If the value is zero then RSSI threshold is not considered when doing a seek. Default value is 25 dBuV.0x0019
.equ RX_VOLUME						= 0x4000 ; Sets the output volume. 0x003F										
.equ RX_HARD_MUTE					= 0x4001 ; Mutes the audio output. L and R audio outputs may be muted independently in FM mode. 0x0000

; STATUS-BITS									
.equ STATUS_BIT_CTS 				=128
.equ STATUS_BIT_ERR  				=64
.equ STATUS_BIT_RSQINT 				=8
.equ STATUS_BIT_RDSINT				=4  
.equ STATUS_BIT_STCINT				=1
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_ABFRAGEN:
	LDS temp,(adr_MODUS_AM_FM)
	cpi temp,MODUS_LW
	breq SI4735_ABFRAGEN_AM
	cpi temp,MODUS_MW
	breq SI4735_ABFRAGEN_AM
	cpi temp,MODUS_KW
	breq SI4735_ABFRAGEN_AM
	cpi temp,MODUS_FM
	breq SI4735_ABFRAGEN_FM
	ret
;-------------------------------------------------------------------------------
SI4735_ABFRAGEN_AM:
	rcall SI4735_AM_TUNE_STATUS
	rcall SI4735_AM_RSQ_STATUS
	ret
;-------------------------------------------------------------------------------
SI4735_ABFRAGEN_FM:
	call SI4735_RDS
	call SI4735_FM_RSQ_STATUS		; RSQ				
	call SI4735_FM_TUNE_STATUS
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SI4739 aus																	
SI4735_POWER_DOWN:
	STS(adr_TUNE_FREQUENZ_L),NULL
	STS(adr_TUNE_FREQUENZ_H),NULL
	call RDS_CLEAR								; RDS clear
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1						; MT-START	
	ldi temp1,(POWER_DOWN)
	call TWI_MT_DATA_TEMP1						; DATA	; CMD		
	call TWI_STOP
	ldi temp,MODUS_AUS		
	STS(adr_MODUS_AM_FM),temp
	jmp wait_100ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
; auf Status warten																
SI4735_INT_STATUS_WAIT:
	call SI4735_GET_INT_STATUS
	LDS temp,(adr_STATUS)
	andi temp,0x80
	tst temp
	breq SI4735_INT_STATUS_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit 	D7 	D6 	D5 	D4 	D3 		D2 		D1 	D0									
;STATUS CTS	ERR X 	X 	RSQINT 	RDSINT 	X 	STCINT								
; Bit7 CTS 		= Clear to Send. 0 = Wait before sending next command. 1 = Clear to send next command.
; Bit6 ERR 		= Error. 0 = No error 1 = Error														
; Bit3 RSQINT 	= Received Signal Quality Interrupt. 0 = Received Signal Quality measurement has not been triggered.1 = Received Signal Quality measurement has been triggered.
; Bit2 RDSINT 	= Radio Data System (RDS) Interrupt. 0 = Radio data system interrupt has not been triggered.1 = Radio data system interrupt has been triggered.
; Bit0 STCINT 	= Seek/Tune Complete Interrupt. 0 = Tune complete has not been triggered. 1 = Tune complete has been triggered.
SI4735_GET_INT_STATUS:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1	; MT-START	
	ldi temp1,(GET_INT_STATUS)
	call TWI_MT_DATA_TEMP1				; DATA				; CMD		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MR_START_TEMP1		; MR-START	
	call TWI_MR_LAST_DATA_TEMP1		; STATUS	
	STS(adr_STATUS),temp1
;-------------------------------------------------------------------------------
	LDS temp,(adr_STATUS)
	andi temp,0b01000000
	tst temp
	brne SI4735_GET_INT_STATUS_ERROR
	ret
;-------------------------------------------------------------------------------
SI4735_GET_INT_STATUS_ERROR:
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 0 0 1 0 0 1 0															
; ARG1 0 0 0 0 0 0 0 0															
; ARG2 Property High Byte.		(temp2)											
; ARG3 Property Low Byte.		(temp1)											
; ARG4 Property Value High Byte.(temp4)											
; ARG5 Property Value Low Byte.	(temp3)											
SI4735_SET_PROPERTY_TEMP1_4:
	push temp3
	push temp4
	push temp1
	push temp2
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1	; MT-START	
	ldi temp1,(SET_PROPERTY)
	call TWI_MT_DATA_TEMP1		; CMD		
	ldi temp1,0					; NULL
	call TWI_MT_DATA_TEMP1		; ARG 1		
	pop temp1 					; (temp2)
	call TWI_MT_DATA_TEMP1		;Property High Byte			(temp2)	
	pop temp1 					; (temp1)
	call TWI_MT_DATA_TEMP1		;Property Low Byte			(temp1)	
	pop temp1 					; (temp4)
	call TWI_MT_DATA_TEMP1		;Property Value High Byte	(temp4)	
	pop temp1 					; (temp3)
	call TWI_MT_DATA_TEMP1		;Property Value Low Byte 	(temp3)	
	call TWI_STOP				; STOPP		
	rjmp SI4735_INT_STATUS_WAIT	; wait...
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 0 0 1 0 0 1 0															
; ARG1 0 0 0 0 0 0 0 0															
; ARG2 Property High Byte.		(temp2)											
; ARG3 Property Low Byte.		(temp1)											
;																				
;Response:																		
; Bit 		D7 	D6 	D5 	D4 	D3 		D2 		D1 	D0								
; STATUS 	CTS ERR X 	X 	RSQINT 	RDSINT 	X 	STCINT							
; RESP1 	0 	0 	0 	0 	0 		0 		0 	0								
; RESP2 	Property Value High Byte.	(temp2)											
; RESP3 	Property Value Low Byte.	(temp1)											
SI4735_GET_PROPERTY_TEMP1_2:
	push temp1
	push temp2
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(GET_PROPERTY)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0		
	call TWI_MT_DATA_TEMP1			; ARG 1 (NULL)				
	pop temp1 ; (temp2)
	call TWI_MT_DATA_TEMP1			; ARG 2 Property High Byte	
	pop temp1 ; (temp1)
	call TWI_MT_DATA_TEMP1			; ARG 3 Property Low Byte	
	call TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MR_START_TEMP1		; MR-START	

	call TWI_MR_DATA_TEMP1			; STATUS	
	STS(adr_STATUS),temp1				; STATUS	
	call TWI_MR_DATA_TEMP1			; RESP1		
										; DUMMY
	call TWI_MR_DATA_TEMP1			; RESP2		;Property Value HIGH Byte.
	mov temp2,temp1					
	call TWI_MR_LAST_DATA_TEMP1		; RESP3		;Property Value Low Byte.	
	jmp TWI_STOP								; STOPP		
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_VOLUME_EINBLENDEN:
	ldi temp1,50
SI4735_VOLUME_ON_s:
	push temp1
	call SI4735_VOLUME_SET_TEMP1
	call WAIT_10ms
	pop temp1
	inc temp1
	cpi temp1,63+1
	brlo SI4735_VOLUME_ON_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_VOLUME_OFF:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RX_VOLUME	(0...63 default is 63 dB)											
SI4735_VOLUME_SET_TEMP1:
	; auf 63 begrenzen		
	cpi temp1,(63+1)
	brlo SI4735_VOLUME_SET_w
	ldi temp1,63
;-------------------------------------------------------------------------------
SI4735_VOLUME_SET_w:
	STS(adr_VOLUME),temp1				; save						
	ldi temp1,LOW (RX_VOLUME)			;Property Low Byte			
	ldi temp2,HIGH(RX_VOLUME)			;Property High Byte			
	LDS temp3,(adr_VOLUME)
	LDS temp3,(adr_VOLUME)				;Property Value Low Byte	
	ldi temp4,0							;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
	; auslesen				
	rjmp SI4735_RX_VOLUME_READ_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_RX_VOLUME_READ_TEMP1:
	ldi temp1,LOW (RX_VOLUME)			;Property Low Byte
	ldi temp2,HIGH(RX_VOLUME)			;Property High Byte
	call SI4735_GET_PROPERTY_TEMP1_2
	STS(adr_VOLUME),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


