; ##############################################################################
; ##############################################################################
; ##############################################################################
; ARG1 CTSIEN GPO2OEN PATCH XOSCEN FUNC[3:0]												
; ARG2 OPMODE[7:0]																			
;																							
; ARG1 7 CTSIEN CTS Interrupt Enable. 0 = CTS interrupt disabled. 1 = CTS interrupt enabled.
; ARG1 6 GPO2OEN GPO2 Output Enable. 0 = GPO2 output disabled. 1 = GPO2 output enabled.		
; ARG1 5 PATCH Patch Enable. 0 = Boot normally. 1 = Copy NVM to RAM, but do not boot. After CTS has been set, RAM may be patched.
; ARG1 4 XOSCEN Crystal Oscillator Enable. 0 = Use external RCLK (crystal oscillator disabled). 1 = Use crystal oscillator (RCLK and GPO3/DCLK with external 32.768 kHz crystal and OPMODE=00000101).
;!ARG1 3:0 FUNC[3:0] Function. 0 = FM Receive. 114 = Reserved. 15 = Query Library ID.										
; ARG2 7:0 OPMODE[7:0] Application Setting.										
;					00000000 = RDS output only (no audio outputs) Si4749 only	
;					00000101 = Analog audio outputs (LOUT/ROUT).				
;					00001011 = Digital audio output (DCLK, LOUT/DFS, ROUT/DIO)	
;					10110000 = Digital audio outputs (DCLK, DFS, DIO)			
SI4735_FM:
	LED_GRUEN_AUS
	LED_GELB_AN
	call TFT_CLEAR
	call ZEILE3
	call TEXT_RADIO
	call TEXT_FM
	call ZEILE5
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	tst ERROR
	breq SI4735_FM_w
	jmp TEXT_ERROR
;-------------------------------------------------------------------------------
SI4735_FM_w:
	call TEXT_A									;
	call SI4735_POWER_DOWN						; AUS		
;-------------------------------------------------------------------------------
	call TEXT_B									;
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(POWER_UP)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00010000	; 32kHz Quarz, FM
	call TWI_MT_DATA_TEMP1			; ARG		
	ldi temp1,0b00000101	; Analog Output
	call TWI_MT_DATA_TEMP1			; ARG		
	call TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	; Pause wichtig	(100ms)		
	call TEXT_C									;
	call wait_500ms
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	tst ERROR
	breq SI4735_FM_w2
	jmp TEXT_ERROR
;-------------------------------------------------------------------------------
SI4735_FM_w2:
	call SI4735_INT_STATUS_WAIT
;-------------------------------------------------------------------------------
	; RX_VOLUME	(0...63 default is 63 dB)
	call TEXT_D									;
	ldi temp1,(63)	
	call SI4735_VOLUME_SET_TEMP1
;-------------------------------------------------------------------------------
	; FM_SEEK_BAND_BOTTOM	
	call TEXT_E									;
	ldi temp1,LOW (FM_SEEK_BAND_BOTTOM)	;Property Low Byte			
	ldi temp2,HIGH(FM_SEEK_BAND_BOTTOM)	;Property High Byte			
	ldi temp3,LOW (8600)				;Property Value Low Byte	
	ldi temp4,HIGH(8600)				;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
;-------------------------------------------------------------------------------
	; FM_SEEK_BAND_TOP 		
	call TEXT_F									;
	ldi temp1,LOW (FM_SEEK_BAND_TOP)	;Property Low Byte			
	ldi temp2,HIGH(FM_SEEK_BAND_TOP)	;Property High Byte			
	ldi temp3,LOW (10800)				;Property Value Low Byte	
	ldi temp4,HIGH(10800)				;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
;-------------------------------------------------------------------------------
	; FREQUENZ				
	call TEXT_G									;
;	ldi temp1,LOW (9440)				; MDR
;	ldi temp2,HIGH(9440)
	ldi temp1,LOW (8600)
	ldi temp2,HIGH(8600)
	call SI4735_FM_TUNE_FREQ_TEMP1_2
;-------------------------------------------------------------------------------
	; RDS					
	call TEXT_H									;
	call SI4735_FM_RDS_INITIALISIERUNG
;-------------------------------------------------------------------------------
	ldi temp,(MODUS_FM)		; MODUS					
	STS(adr_MODUS_AM_FM),temp
;-------------------------------------------------------------------------------
	LED_GRUEN_AN
	LED_GELB_AUS
	call ASCII_PUNKT3
	call TEXT_OK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit  D7 D6 D5 D4 D3 D2 D1 D0		
; CMD  0  0  1  0  0  0  1  1		
; ARG1 0  0  0  0  0  0  0  INTACK	
;									
; ARG1 0 INTACK Interrupt Acknowledge.0 = Interrupt status preserved. 1 = Clears RSQINT, BLENDINT, SNRHINT, SNRLINT, RSSIHINT, RSSILINT,MULTHINT, MULTLINT
;									
; Bit 		D7 	D6 D5 D4 D3 D2 D1 D0
; STATUS 	CTS ERR X X RSQINT RDSINT X STCINT
; RESP1 	BLENDINT X MULTHINT MULTLINT SNRHINT SNRLINT RSSIHINT RSSIILINT
; RESP2 	X X X X SMUTE X AFCRL VALID
; RESP3 	PILOT STBLEND[6:0]		
; RESP4 	RSSI[7:0]				
; RESP5 	SNR[7:0]				
; RESP6 	MULT[7:0]				
; RESP7 	FREQOFF[7:0]			
;									
; RESP1 7 BLENDINT - Blend Detect Interrupt. 0 = Blend is within the Blend threshold settings.1 = Blend goes above or below the Blend threshold settings.
; RESP1 5 MULTHINT - Multipath Detect High   0 = Detected multipath value has not exceeded above the Multipath high threshold. 1 = Detected multipath value has exceeded above the Multipath high threshold.
; RESP1 4 MULTLINT - Multipath Detect Low 0 = Detected multipath value has not fallen below the Multipath low threshold. 1 = Detected multipath value has fallen below the Multipath low threshold.
; RESP1 3 SNRHINT  - SNR Detect High.0 = Received SNR has not exceeded above SNR high threshold.1 = Received SNR has exceeded above SNR high threshold.
; RESP1 2 SNRLINT  - SNR Detect Low. 0 = Received SNR has not fallen below SNR low threshold. 1 = Received SNR has fallen below SNR low threshold.
; RESP1 1 RSSIHINT - RSSI Detect High. 0 = RSSI has not exceeded above RSSI high threshold.1 = RSSI has exceeded above RSSI high threshold.
; RESP1 0 RSSILINT - RSSI Detect Low. 0 = RSSI has not fallen below RSSI low threshold. 1 = RSSI has fallen below RSSI low threshold.
; RESP2 3 SMUTE    - Soft Mute Indicator. Indicates soft mute is engaged.														
; RESP2 1 AFCRL    - AFC Rail Indicator. Set if the AFC rails.																	
; RESP2 0 VALID    - Valid Channel. Set if the channel is currently valid and would have been found during a Seek.				
;!RESP3 7 PILOT    - Pilot Indicator. Indicates stereo pilot presence.															
;!RESP3 6:0 STBLEND- Stereo Blend Indicator. Indicates amount of stereo blend in% (100 = full stereo, 0 = full mono).			
;!RESP4 7:0 RSSI   - Received Signal Strength Indicator. Contains the current receive signal strength (0127 dBV).				
;!RESP5 7:0 SNR    - SNR. Contains the current SNR metric (0127 dB).															
; RESP6 7:0 MULT   - Multipath Contains the current multipath metric. (0 = no multipath; 100 = full multipath)					
; RESP7 7:0 FREQOFF- Frequency Offset. Signed frequency offset (kHz)															
;																																
SI4735_FM_RSQ_STATUS:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1			; MT-START	
	ldi temp1,(FM_RSQ_STATUS)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00000000			;  INTACK	
	call TWI_MT_DATA_TEMP1			; ARG		
	call TWI_STOP					; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MR_START_TEMP1			; MR-START	
	call TWI_MR_DATA_TEMP1			; STATUS	
	STS(adr_STATUS),temp1			; STATUS	
	call TWI_MR_DATA_TEMP1			; RESP1		
	call TWI_MR_DATA_TEMP1			; RESP2		
	call TWI_MR_DATA_TEMP1			; RESP3		
	mov temp,temp1
	andi temp,0b10000000	; PILOT 		
	STS(adr_PILOT),temp
	andi temp1,0b01111111	; STBLEND[6:0]	
	STS(adr_STBLEND),temp1
STS PWM_ZEIG,temp1			; PWM
	call TWI_MR_DATA_TEMP1			; RESP4		
	STS(adr_RSSI),temp1		; RSSI			
	call TWI_MR_DATA_TEMP1			; RESP5		
	STS(adr_SNR),temp1		; SNR			
	call TWI_MR_DATA_TEMP1			; RESP6		
	STS(adr_MULT),temp1		; MULT			
	call TWI_MR_LAST_DATA_TEMP1		; RESP7		FREQOFF
;-------------------------------------------------------------------------------
; STEREO / Verkehrsdurchsage													
	LDS temp,(adr_PILOT)
	tst temp
	brne SI4735_FM_RSQ_STEREO
	LED_STEREO_AUS
	rjmp SI4735_FM_RSQ_FERTIG
;-------------------------------------------------------------------------------
SI4735_FM_RSQ_STEREO:
	LED_STEREO_AN
	LDS temp,(adr_RDS_TA)		; Verkehrsdurchsage
	tst temp
	breq SI4735_FM_RSQ_FERTIG
	call WAIT_20ms
	LED_STEREO_AUS
;-------------------------------------------------------------------------------
SI4735_FM_RSQ_FERTIG:
	rjmp SI4735_INT_STATUS_WAIT				; wait...
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit D7 D6 D5 D4 D3 D2 D1 D0		
; CMD 0 0 1 0 0 0 0 0				
; ARG1 0 0 0 0 0 0 FREEZE FAST		
; ARG2 FREQH[7:0]					
; ARG3 FREQL[7:0]					
; ARG4 ANTCAP[7:0]					
;									
; ARG1 1 FREEZE Freeze Metrics During Alternate Frequency Jump. If set will cause the blend, hicut, and softmute to transition as a function of theassociated attack/release parameters rather than instantaneously when tuning to alternate station.
; ARG1 0 FAST FAST Tuning. If set, executes fast and invalidated tune. The tune status will not be accurate.
; ARG2 7:0 FREQH[7:0] Tune Frequency High Byte. This byte in combination with FREQL selects the tune frequency in 10 kHz. In FM mode the valid range is from 6400 to 10800 (64108 MHz).
; ARG3 7:0 FREQL[7:0] Tune Frequency Low Byte. This byte in combination with FREQH selects the tune frequency in 10 kHz. In FM mode the valid range is from 6400 to 10800 (64108 MHz).
; ARG4 7:0 ANTCAP[7:0] Antenna Tuning Capacitor 										
SI4735_FM_TUNE_FREQ_TEMP1_2:
	; FREQUENZ schon eingestellt ?
	LDS temp,(adr_TUNE_FREQUENZ_L)
	cp temp,temp1
	brne SI4735_FM_TUNE_FREQ_TEMP1_2_RUN
	LDS temp,(adr_TUNE_FREQUENZ_H)
	cp temp,temp2
	brne SI4735_FM_TUNE_FREQ_TEMP1_2_RUN
	ret
;---------------------------------------------------------------------------------------
SI4735_FM_TUNE_FREQ_TEMP1_2_RUN:
	STS(adr_TUNE_FREQUENZ_L),temp1
	STS(adr_TUNE_FREQUENZ_H),temp2
	ldi temp1,(17)
	call TWI_MT_START_TEMP1			; MT-START	
	ldi temp1,(FM_TUNE_FREQ)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0x00000000	; FREEZE FAST
	call TWI_MT_DATA_TEMP1			; ARG		
	LDS temp1,(adr_TUNE_FREQUENZ_H);(Frequenz_H)
	call TWI_MT_DATA_TEMP1			; ARG		
	LDS temp1,(adr_TUNE_FREQUENZ_L);(Frequenz_L)
	call TWI_MT_DATA_TEMP1			; ARG		
	ldi temp1,0x00
	call TWI_MT_DATA_TEMP1			; ARG		
	call TWI_STOP
	call SI4735_INT_STATUS_WAIT		; wait...

;	STS(adr_TUNE_FREQUENZ_L),NULL
;	STS(adr_TUNE_FREQUENZ_H),NULL


	rjmp RDS_CLEAR					; RDS clear
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_FM_STEPP_UP:
	LDS temp1,(adr_TUNE_FREQUENZ_L)
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	ldi temp,1
	add temp1,temp
	adc temp2,NULL
	rjmp SI4735_FM_TUNE_FREQ_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_FM_STEPP_DOWN:
	LDS temp1,(adr_TUNE_FREQUENZ_L)
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	ldi temp,1
	sub temp1,temp
	sbc temp2,NULL
	rjmp SI4735_FM_TUNE_FREQ_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  	0 0 1 0 0 0 0 1															
; ARG1 	0 0 0 0 SEEKUP WRAP 0 0													
; ARG1 3 SEEKUP Seek Up/Down. Determines the direction of the search, either UP = 1, or DOWN = 0.					
; ARG1 2 WRAP Wrap/Halt. Determines whether the seek should Wrap = 1, or Halt = 0 when it hits the band limit.		
SI4735_FM_SEEK_START_UP:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(FM_SEEK_START)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00001100	; SEEK-UP WRAP
	call TWI_MT_DATA_TEMP1			; ARG		
	call TWI_STOP
	call SI4735_INT_STATUS_WAIT				; wait...
	rjmp RDS_CLEAR			; RDS clear
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  	0 0 1 0 0 0 0 1															
; ARG1 	0 0 0 0 SEEKUP WRAP 0 0													
; ARG1 3 SEEKUP Seek Up/Down. Determines the direction of the search, either UP = 1, or DOWN = 0.					
; ARG1 2 WRAP Wrap/Halt. Determines whether the seek should Wrap = 1, or Halt = 0 when it hits the band limit.		
SI4735_FM_SEEK_START_DOWN:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(FM_SEEK_START)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00000100	; SEEK-UP WRAP
	call TWI_MT_DATA_TEMP1			; ARG		
	call TWI_STOP
	call SI4735_INT_STATUS_WAIT				; wait...
	rjmp RDS_CLEAR			; RDS clear
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 0 1 0 0 0 1 0																						
; ARG1 0 0 0 0 0 0 CANCEL INTACK																			
;																											
; ARG1 1 CANCEL Cancel seek. If set, aborts a seek currently in progress.									
; ARG1 0 INTACK Seek/Tune Interrupt Clear. If set, clears the seek/tune complete interrupt status indicator.
;																											
; Response																									
; Bit    D7   D6   D5  D4  D3     D2       D1    D0								
; STATUS CTS  ERR  X   X   RSQINT RDSINT   X     STCINT							
; RESP1  BLTF  X   X   X   X      X        AFCRL VALID							
; RESP2 READFREQH[7:0]															
; RESP3 READFREQL[7:0]															
; RESP4 RSSI[7:0]																
; RESP5 SNR[7:0]																
; RESP6 MULT[7:0]																
; RESP7 READANTCAP[7:0] (Si4704/05/06/2x only)									
;																				
; RESP1 7 BLTF Band Limit.Reports if a seek hit the band limit (WRAP = 0 in FM_START_SEEK) or wrapped to the original frequency (WRAP = 1).
; RESP1 6:2 Reserved Always returns 0.						
; RESP1 1 AFCRL AFC Rail Indicator. Set if the AFC rails.	
; RESP1 0 VALID Valid Channel.Set if the channel is currently valid as determined by the seek/tune properties(0x1403, 0x1404, 0x1108) and would have been found during a Seek.
; RESP2 7:0 READFREQH[7:0]Read Frequency High Byte.(10 kHz)	
; RESP3 7:0 READFREQL[7:0]Read Frequency Low Byte.(10 kHz)	
; RESP4 7:0 RSSI[7:0] Received Signal Strength Indicator. This byte contains the receive signal strength when tune is complete (dBV).
; RESP5 7:0 SNR[7:0] SNR. This byte contains the SNR metric when tune is complete (dB).
; RESP6 7:0 MULT[7:0] Multipath. This byte contains the multipath metric when tune is complete. Multipath indicator is available only for Si474x, Si4706-C30 and later andSi4704/05/30/31/34/35/84/85 -D50 and later.
; RESP7 7:0 READANTCAP [7:0] Read Antenna Tuning Capacitor (Si4704/05/06/2x only). This byte contains the current antenna tuning capacitor value.
SI4735_FM_TUNE_STATUS:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(FM_TUNE_STATUS)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00000001	; CANCEL INTACK
	call TWI_MT_DATA_TEMP1			; ARG1		
;	call TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MR_START_TEMP1						; MR-START	
	call TWI_MR_DATA_TEMP1			; STATUS	
	STS(adr_STATUS),temp1			; STATUS	
	call TWI_MR_DATA_TEMP1			; RESP1		
	call TWI_MR_DATA_TEMP1			; RESP2		
	STS(adr_TUNE_FREQUENZ_H),temp1; Frequenz (H)
	call TWI_MR_DATA_TEMP1			; RESP3		
	STS(adr_TUNE_FREQUENZ_L),temp1; Frequenz (L)
	call TWI_MR_DATA_TEMP1			; RESP4		
	STS(adr_RSSI),temp1				;RSSI
	call TWI_MR_DATA_TEMP1			; RESP5		
	STS(adr_SNR),temp1				;SNR
	call TWI_MR_DATA_TEMP1			; RESP6		
	STS(adr_MULT),temp1				;MULT
	call TWI_MR_LAST_DATA_TEMP1		; RESP7		
;	call TWI_STOP								; STOPP		
	rjmp SI4735_INT_STATUS_WAIT					; wait...
; ##############################################################################
; ##############################################################################
; ##############################################################################

