; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_FM_RDS_INITIALISIERUNG:
	call RDS_CLEAR

	ldi temp1,LOW (FM_RDS_INT_SOURCE)		;Property Low Byte			
	ldi temp2,HIGH(FM_RDS_INT_SOURCE)		;Property High Byte			
	ldi temp3,0b00000001					;Property Value Low Byte	
	ldi temp4,0b00000000					;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4

	ldi temp1,LOW (FM_RDS_INT_FIFO_COUNT)	;Property Low Byte			
	ldi temp2,HIGH(FM_RDS_INT_FIFO_COUNT)	;Property High Byte			
	ldi temp3,LOW (1)						;Property Value Low Byte	
	ldi temp4,HIGH(1)						;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4

	ldi temp1,LOW (FM_RDS_CONFIG)			;Property Low Byte			
	ldi temp2,HIGH(FM_RDS_CONFIG)			;Property High Byte			
	ldi temp3,0x01 ;RDSEN				;Property Value Low Byte		
	ldi temp4,0b10101010;(Block Error Threshold BLOCKA...C)	;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_CLEAR:
	call SI4735_RDS

	STS(adr_RDS_PI_L),NULL
	STS(adr_RDS_PI_H),NULL

	STS(adr_RDS_PTY),NULL
	STS(adr_RDS_TP),NULL
	STS(adr_RDS_TA),NULL
	STS(adr_RDS_MS),NULL

	STS(adr_RDS_ZEIT_HH),NULL
	STS(adr_RDS_ZEIT_MM),NULL
	STS(adr_RDS_ZEIT_OFFSET),NULL

	STS(adr_RDS_DATUM0),NULL
	STS(adr_RDS_DATUM1),NULL
	STS(adr_RDS_DATUM2),NULL

	STS(adr_RDS_TAG),NULL
	STS(adr_RDS_MONAT),NULL
	STS(adr_RDS_JAHR),NULL

	STS(adr_RDS_4A_AH),NULL
	STS(adr_RDS_4A_AL),NULL
	STS(adr_RDS_4A_BH),NULL
	STS(adr_RDS_4A_BL),NULL
	STS(adr_RDS_4A_CH),NULL
	STS(adr_RDS_4A_CL),NULL
	STS(adr_RDS_4A_DH),NULL
	STS(adr_RDS_4A_DL),NULL

	; SCHLEIFE (8)		
	ldi ZL, LOW (adr_SENDERNAME8)
	ldi ZH, HIGH(adr_SENDERNAME8)
	ldi temp1,8
	ldi temp,'_'
RDS_CLEAR_w0:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w0
	; SCHLEIFE (8)		
	ldi ZL, LOW (adr_RDS_SENDERNAME8)
	ldi ZH, HIGH(adr_RDS_SENDERNAME8)
	ldi temp1,8
	ldi temp,'_'
RDS_CLEAR_w1:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w1
	; SCHLEIFE (128)	
	ldi ZL, LOW (adr_RDS_BEREICH_RADIOTEXT128)
	ldi ZH, HIGH(adr_RDS_BEREICH_RADIOTEXT128)
	ldi temp1,128
RDS_CLEAR_w2:
	ldi temp,'_'
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w2
	; SCHLEIFE (32)		
	ldi ZL, LOW (adr_RDS_BEREICH_GT32)
	ldi ZH, HIGH(adr_RDS_BEREICH_GT32)
	ldi temp1,32
RDS_CLEAR_w3:
	clr temp
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w3
	; SCHLEIFE (205)	
	ldi ZL, LOW (adr_RDS_BEREICH_AF205)
	ldi ZH, HIGH(adr_RDS_BEREICH_AF205)
	ldi temp1,205
	clr temp
RDS_CLEAR_w4:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit 	D7 	D6 	D5 	D4 	D3 	D2 			D1 		D0		
; CMD 	0 	0 	1 	0 	0 	1 			0 		0		
; ARG1 	0 	0 	0 	0 	0 	STATUSONLY 	MTFIFO 	INTACK	
;														
; ARG1 2 STATUSONLY Status Only. Determines if data should be removed from the RDS FIFO.0 = Data in BLOCKA, BLOCKB, BLOCKC, BLOCKD, and BLE contain the oldestdata in the RDS FIFO.1 = Data in BLOCKA will contain the last valid block A data received for the current station. Data in BLOCKB will contain the last valid block B data received for the current station. Data in BLE will describe the bit errors for the data in BLOCKA and BLOCKB.
; ARG1 1 MTFIFO Empty FIFO 0 = If FIFO not empty, read and remove oldest FIFO entry. 1 = Clear RDS Receive FIFO.	
; ARG1 0 INTACKInterrupt Acknowledge0 = RDSINT status preserved.1 = Clears RDSINT.									
;																													
; Response																											
; Bit 		D7 	D6 	D5 				D4 				D3 		D2 				D1 			D0							
; STATUS 	CTS ERR X 				X 				RSQINT 	RDSINT 			X 			STCINT						
; RESP1 	X 	X 	RDSNEWBLOCKB 	RDSNEWBLOCKA 	X 		RDSSYNCFOUND 	RDSSYNCLOST RDSRECV						
; RESP2 	X 	X 	X 				X 				X 		GRPLOST 		X 			RDSSYNC						
; RESP3 RDSFIFOUSED[7:0]	
; RESP4 BLOCKA[15:8]		
; RESP5 BLOCKA[7:0]			
; RESP6 BLOCKB[15:8]		
; RESP7 BLOCKB[7:0]			
; RESP8 BLOCKC[15:8]		
; RESP9 BLOCKC[7:0]			
; RESP10 BLOCKD[15:8]		
; RESP11 BLOCKD[7:0]		
; RESP12 BLEA[1:0] BLEB[1:0] BLEC[1:0] BLED[1:0]
;-------------------------------------------------------------------------------
SI4735_RDS:
	STS(adr_RDS_TA),NULL			; immer zurcksetzen 
	call SI4735_GET_INT_STATUS
	LDS temp,(adr_STATUS)
	andi temp,(STATUS_BIT_RDSINT)	; BIT herausfiltern	
	tst temp
	brne SI4735_RDS_RUN
	LED_GRUEN_AUS
	ret
;-------------------------------------------------------------------------------
SI4735_RDS_RUN:
	; Status abfragen		
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(FM_RDS_STATUS)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0x00000001	; 	STATUSONLY,MTFIFO,INTACK	
	call TWI_MT_DATA_TEMP1			; ARG		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MR_START_TEMP1		; MR-START	
	call TWI_MR_DATA_TEMP1			; STATUS	
	STS(adr_STATUS),temp1
	call TWI_MR_DATA_TEMP1			; RESP1		
	call TWI_MR_DATA_TEMP1			; RESP2		
	call TWI_MR_DATA_TEMP1			; RESP3		
	STS(adr_RDS_FIFO),temp1; RDS FIFO Used
	call TWI_MR_DATA_TEMP1			; RESP4		
	STS(adr_RDS_BLOCK_AH),temp1	; BLOCK-AH
	call TWI_MR_DATA_TEMP1			; RESP5		
	STS(adr_RDS_BLOCK_AL),temp1	; BLOCK-AL
	call TWI_MR_DATA_TEMP1			; RESP6		
	STS(adr_RDS_BLOCK_BH),temp1	; BLOCK-BH
	call TWI_MR_DATA_TEMP1			; RESP7		
	STS(adr_RDS_BLOCK_BL),temp1	; BLOCK-BL
	call TWI_MR_DATA_TEMP1			; RESP8		
	STS(adr_RDS_BLOCK_CH),temp1	; BLOCK-CH
	call TWI_MR_DATA_TEMP1			; RESP9		
	STS(adr_RDS_BLOCK_CL),temp1	; BLOCK-CL
	call TWI_MR_DATA_TEMP1			; RESP10	
	STS(adr_RDS_BLOCK_DH),temp1	; BLOCK-DH
	call TWI_MR_DATA_TEMP1			; RESP11	
	STS(adr_RDS_BLOCK_DL),temp1	; BLOCK-DL
	call TWI_MR_LAST_DATA_TEMP1		; RESP12	
	STS(adr_RDS_ERROR),temp1; RDS-ERROR	
	call RDS_AUSWERTUNG
;-------------------------------------------------------------------------------
	LDS temp,(adr_RDS_FIFO); RDS FIFO Used
	cpi temp,2
	brsh SI4735_RDS_w
	call TWI_STOP			; STOPP		
	ret
;-------------------------------------------------------------------------------
SI4735_RDS_w:
	rjmp SI4735_RDS_RUN
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_AUSWERTUNG:
	call ZAHLER_PLUS_EINS
	; NULL BLOCK-A
	LDS temp,(adr_RDS_BLOCK_AH)
	tst temp
	breq RDS_AUSWERTUNG_ERROR_SCHWER
	; NULL BLOCK-A
	LDS temp,(adr_RDS_BLOCK_AL)
	tst temp
	breq RDS_AUSWERTUNG_ERROR_SCHWER
;-------------------------------------------------------------------------------
	; ERROR			
	LDS temp,(adr_RDS_ERROR)
	tst temp
	breq RDS_AUSWERTUNG_OK
	LED_GELB_AN
	call WAIT_1ms
	LED_GELB_AUS
	rjmp RDS_AUSWERTUNG_GRUPPENTYP
;-------------------------------------------------------------------------------
RDS_AUSWERTUNG_OK:
	LED_GRUEN_AN
	rjmp RDS_AUSWERTUNG_GRUPPENTYP
;-------------------------------------------------------------------------------
RDS_AUSWERTUNG_ERROR_SCHWER:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_AUSWERTUNG_GRUPPENTYP:
	; GT (Gruppentyp) filtern		
	LDS temp,(adr_RDS_BLOCK_BH)
	LSR temp	; 3 mal rechts
	LSR temp	; 
	LSR temp	; 
	STS(adr_RDS_GT),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; GT fr Anzeige speichern		
	LDS temp,(adr_RDS_ERROR)		; Error ?		
	tst temp
	brne RDS_AUSWERTUNG_GRUPPENTYP_w
	LDS temp,(adr_RDS_GT)
	ldi ZL,LOW (adr_RDS_BEREICH_GT32)
	ldi ZH,HIGH(adr_RDS_BEREICH_GT32)
	add ZL,temp ; temp addieren	
	adc ZH,NULL
	ldi temp,'*'
	ST z+,temp 	; temp save		
RDS_AUSWERTUNG_GRUPPENTYP_w:
;-------------------------------------------------------------------------------
	; GT (Gruppentyp) auswerten	
	LDS temp,(adr_RDS_GT)
	ldi ZL,LOW (RDS_AUSWERTUNG_SPRUNGMARKE)
	ldi ZH,HIGH(RDS_AUSWERTUNG_SPRUNGMARKE)
	add ZL,temp ; temp addieren
	adc ZH,NULL
	ijmp		; SPRUNG nach Z		
;-------------------------------------------------------------------------------
RDS_AUSWERTUNG_SPRUNGMARKE:
	rjmp RDS_GT_0A			; Sendername, TA, Musik/Sprache	(M/S)
	ret		;rjmp RDS_GT_0B
	ret		;rjmp RDS_GT_1A
	ret		;rjmp RDS_GT_1B
	rjmp RDS_GT_2A			; Radiotext		
	ret		;rjmp RDS_GT_2B
	ret		;rjmp RDS_GT_3A
	ret		;rjmp RDS_GT_3B
	rjmp RDS_GT_4A			; ZEIT + Datum	
	ret		;rjmp RDS_GT_4B
	ret		;rjmp RDS_GT_5A
	ret		;rjmp RDS_GT_5B
	ret		;rjmp RDS_GT_6A
	ret		;rjmp RDS_GT_6B
	ret		;rjmp RDS_GT_7A
	ret		;rjmp RDS_GT_7B
	ret		;rjmp RDS_GT_8A
	ret		;rjmp RDS_GT_8B
	ret		;rjmp RDS_GT_9A
	ret		;rjmp RDS_GT_9B
	ret		;rjmp RDS_GT_10A
	ret		;rjmp RDS_GT_10B
	ret		;rjmp RDS_GT_11A
	ret		;rjmp RDS_GT_11B
	ret		;rjmp RDS_GT_12A
	ret		;rjmp RDS_GT_12B
	ret		;rjmp RDS_GT_13A
	ret		;rjmp RDS_GT_13B
	ret		;rjmp RDS_GT_14A
	ret		;rjmp RDS_GT_14B
	ret		;rjmp RDS_GT_15A
	ret		;rjmp RDS_GT_15B
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Sendername, TA, Musik/Sprache	(M/S)											
RDS_GT_0A:
	; ERROR ?				
	LDS temp,(adr_RDS_ERROR)
	tst temp
	breq RDS_GT_0A_RUN
	ret
;-------------------------------------------------------------------------------
RDS_GT_0A_RUN:
	; PI (wird in allen Gruppen gesendet)		
	LDS temp,(adr_RDS_BLOCK_AH)
	STS(adr_RDS_PI_H),temp	; im SRAM ablegen	
	LDS temp,(adr_RDS_BLOCK_AL)
	STS(adr_RDS_PI_L),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; TP (wird in allen Gruppen gesendet)		
	LDS temp,(adr_RDS_BLOCK_BH)
	andi temp,0b00000100	; Bitmuster			
	STS(adr_RDS_TP),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; PTY (wird in allen Gruppen gesendet)		
	LDS temp1,(adr_RDS_BLOCK_BH)
	LDS temp, (adr_RDS_BLOCK_BL)
	LSR temp1	; 5 mal rechts
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	andi temp,0b00011111	; Bitmuster	
	STS(adr_RDS_PTY),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; TA					
	LDS temp,(adr_RDS_BLOCK_BL)
	andi temp,0b00010000	; Bitmuster			
	STS(adr_RDS_TA),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; MS (MUSIK/Sprache)	
	LDS temp,(adr_RDS_BLOCK_BL)
	andi temp,0b00001000	; Bitmuster			
	STS(adr_RDS_MS),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; AF (Alternativ-Frequenz 1)
	LDS temp,(adr_RDS_BLOCK_CH)
	cpi temp,204+1	; 0...204
	brsh RDS_GT_0A_AF1_FERTIG
	; Z-initialisieren	
	ldi ZL, LOW (adr_RDS_BEREICH_AF205)
	ldi ZH, HIGH(adr_RDS_BEREICH_AF205)
	add ZL,temp
	adc ZH,NULL
	ST z+,temp	; im SRAM ablegen	
RDS_GT_0A_AF1_FERTIG:
	; AF (Alternativ-Frequenz 2)
	LDS temp,(adr_RDS_BLOCK_CL)
	cpi temp,204+1	; 0...204
	brsh RDS_GT_0A_AF2_FERTIG
	; Z-initialisieren	
	ldi ZL, LOW (adr_RDS_BEREICH_AF205)
	ldi ZH, HIGH(adr_RDS_BEREICH_AF205)
	add ZL,temp
	adc ZH,NULL
	ST z+,temp	; im SRAM ablegen	
RDS_GT_0A_AF2_FERTIG:
;-------------------------------------------------------------------------------
	; Sendername			
	LDS temp1,(adr_RDS_BLOCK_DH)
	LDS temp2,(adr_RDS_BLOCK_DL)
	; Adresse filtern		
	LDS temp,(adr_RDS_BLOCK_BL)
	andi temp,0b00000011
	cpi temp,0
	breq RDS_0A_ADR0
	cpi temp,1
	breq RDS_0A_ADR1
	cpi temp,2
	breq RDS_0A_ADR2
	cpi temp,3
	breq RDS_0A_ADR3
	; SRAM ablegen			
RDS_0A_ADR0:
	STS(adr_RDS_SENDERNAME8+0),temp1
	STS(adr_RDS_SENDERNAME8+1),temp2
	ret
RDS_0A_ADR1:
	STS(adr_RDS_SENDERNAME8+2),temp1
	STS(adr_RDS_SENDERNAME8+3),temp2
	ret
RDS_0A_ADR2:
	STS(adr_RDS_SENDERNAME8+4),temp1
	STS(adr_RDS_SENDERNAME8+5),temp2
	ret
RDS_0A_ADR3:
	STS(adr_RDS_SENDERNAME8+6),temp1
	STS(adr_RDS_SENDERNAME8+7),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Radiotext																		
RDS_GT_2A:
	; Adresse filtern	
	LDS temp9,(adr_RDS_BLOCK_BL)
	andi temp9,0b00011111
	; mal 4				
	LSL temp9	; x2
	LSL temp9	; x2= POSITION
	; Z-initialisieren	
	ldi ZL, LOW (adr_RDS_BEREICH_RADIOTEXT128)
	ldi ZH, HIGH(adr_RDS_BEREICH_RADIOTEXT128)
	add ZL,temp9
	adc ZH,NULL
	; 1.BYTE im SRAM speichern	
	LDS temp,(adr_RDS_BLOCK_CH)
	call RDS_GT_2A_SONDERZEICHEN_FILTER
	ST z+,temp
	; 2.BYTE im SRAM speichern	
	LDS temp,(adr_RDS_BLOCK_CL)
	inc temp9	; POSITION+1
	call RDS_GT_2A_SONDERZEICHEN_FILTER
	ST z+,temp
	; 3.BYTE im SRAM speichern	
	LDS temp,(adr_RDS_BLOCK_DH)
	inc temp9	; POSITION+1
	call RDS_GT_2A_SONDERZEICHEN_FILTER
	ST z+,temp
	; 4.BYTE im SRAM speichern	
	LDS temp,(adr_RDS_BLOCK_DL)
	inc temp9	; POSITION+1
	call RDS_GT_2A_SONDERZEICHEN_FILTER
	ST z+,temp
	ret
;-------------------------------------------------------------------------------
RDS_GT_2A_SONDERZEICHEN_FILTER:
	; sonderzeichen erkennen	
	cpi temp,32-1
	brlo RDS_GT_2A_SONDERZEICHEN_FILTER_w
	ret
RDS_GT_2A_SONDERZEICHEN_FILTER_w:
	; Y-initialisieren			
	ldi YL, LOW (adr_RDS_BEREICH_RADIOTEXT128)
	ldi YH, HIGH(adr_RDS_BEREICH_RADIOTEXT128)
	add YL,temp9
	adc YH,NULL
	; Fllzeichen				
	ldi temp,' '
	; BLOCK1 oder BLOCK2		
	cpi temp9,63
	brsh RDS_GT_2A_SONDERZEICHEN_BLOCK2
;-------------------------------------------------------------------------------
RDS_GT_2A_SONDERZEICHEN_BLOCK1:
	; SCHLEIFE=64-POSITION		
	ldi temp1,64	; Schleife	
	sub temp1,temp9	
RDS_GT_2A_SONDERZEICHEN_BLOCK1_s:
	ST Y+,temp
	dec temp1
	brne RDS_GT_2A_SONDERZEICHEN_BLOCK1_s
	ret
;-------------------------------------------------------------------------------
RDS_GT_2A_SONDERZEICHEN_BLOCK2:
	; SCHLEIFE=128-POSITION		
	ldi temp1,128	; Schleife	
	sub temp1,temp9	
RDS_GT_2A_SONDERZEICHEN_BLOCK2_s:
	ST Y+,temp
	dec temp1
	brne RDS_GT_2A_SONDERZEICHEN_BLOCK2_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; C |  BLOCK-D(H)	| BLOCK-D(L)				
;  0 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0			
;  0 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0			
; |Stunden  | Minuten   |Offset(30min)			
; ZEIT + Datum																	
RDS_GT_4A:
	; ERROR ?				
	LDS temp,(adr_RDS_ERROR)
	tst temp
	breq RDS_GT_4A_RUN
	ret
;-------------------------------------------------------------------------------
RDS_GT_4A_RUN:
	LDS temp1,(adr_RDS_BLOCK_AH)
	LDS temp2,(adr_RDS_BLOCK_AL)
	LDS temp3,(adr_RDS_BLOCK_BH)
	LDS temp4,(adr_RDS_BLOCK_BL)
	LDS temp5,(adr_RDS_BLOCK_CH)
	LDS temp6,(adr_RDS_BLOCK_CL)
	LDS temp7,(adr_RDS_BLOCK_DH)
	LDS temp8,(adr_RDS_BLOCK_DL)
	STS(adr_RDS_4A_AH),temp1
	STS(adr_RDS_4A_AL),temp2
	STS(adr_RDS_4A_BH),temp3
	STS(adr_RDS_4A_BL),temp4
	STS(adr_RDS_4A_CH),temp5
	STS(adr_RDS_4A_CL),temp6
	STS(adr_RDS_4A_DH),temp7
	STS(adr_RDS_4A_DL),temp8
;-------------------------------------------------------------------------------

	; Offset (in 30 Min)
	LDS temp1,(adr_RDS_BLOCK_DL)
	andi temp1,0b00111111
	STS(adr_RDS_ZEIT_OFFSET),temp1
	; Minuten			
	LDS temp2,(adr_RDS_BLOCK_DH)
	LDS temp1,(adr_RDS_BLOCK_DL)
	LSR temp2	; 6 mal rechts
	ROR temp1

	LSR temp2	;
	ROR temp1

	LSR temp2	;
	ROR temp1

	LSR temp2	;
	ROR temp1

	LSR temp2	;
	ROR temp1

	LSR temp2	;
	ROR temp1

	andi temp1,0b00111111
	STS(adr_RDS_ZEIT_MM),temp1
	; Stunden			
	LDS temp2,(adr_RDS_BLOCK_CL)
	LDS temp1,(adr_RDS_BLOCK_DH)
	LSR temp2	; 4 mal rechts
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	andi temp1,0b00011111
	STS(adr_RDS_ZEIT_HH),temp1
;-------------------------------------------------------------------------------
	; Offsetwert x 30			
	LDS temp1,(adr_RDS_ZEIT_OFFSET)
	mov temp,temp1
	ldi temp9,29	; 29 x addieren
RDS_GT_4A_s:
	add temp1,temp
	dec temp9
	brne RDS_GT_4A_s

	mov temp9,temp1	; Schleife
	LDS temp1,(adr_RDS_ZEIT_mm)	; mm
	LDS temp2,(adr_RDS_ZEIT_hh)	; hh
RDS_GT_4A_SCHLEIFE:
	inc temp1		; mm
	cpi temp1,60
	brsh RDS_GT_4A_HH
	rjmp RDS_GT_4A_w
RDS_GT_4A_HH:
	clr temp1		; mm
	inc temp2		; hh
	cpi temp2,24
	brsh RDS_GT_4A_TAG
	rjmp RDS_GT_4A_w
RDS_GT_4A_TAG:
	clr temp2		; hh
RDS_GT_4A_w:
	dec temp9		; Schleife
	brne RDS_GT_4A_SCHLEIFE
;-------------------------------------------------------------------------------
; Uhr stellen																	
	STS(adr_RDS_ZEIT_mm),temp1	; mm	
	STS(adr_RDS_ZEIT_hh),temp2	; hh	
	STS(adr_mm),temp1			; mm	
	STS(adr_hh),temp2			; hh	
	STS(adr_ss),EINS 			; ss (etwas vorstellen)
;-------------------------------------------------------------------------------
; DATUM																			
	LDS temp,(adr_hh)
	cpi temp,3			; erst ab 3 Uhr Datum stellen
	brsh RDS_GT_4A_DATUM
	ret
;-------------------------------------------------------------------------------
RDS_GT_4A_DATUM:
	rcall RDS_DATUM				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;-------------------------------------------------------------------------------
; Datum																			
; http://www.csgnetwork.com/julianmodifdateconv.html							
; https://en.wikipedia.org/wiki/Radio_Data_System								
;.equ TZ = 58635 ;01.06.2019(Sa)												
;.equ TZ = 58484 ;01.01.2019(Di)												
;.equ TZ = 58849 ;01.01.2020(Mi)												
;.equ TZ = 59215 ;01.01.2021(Fr)												
;.equ TZ = 59580 ;01.01.2022(Sa)												
;.equ TZ = 59945 ;01.01.2023(So)												
;.equ TZ = 60310 ;01.01.2024(Mo)												
;.equ TZ = 60676 ;01.01.2025(Mi)												
;.equ TZ = 75286 ;01.01.2065(Do)												
; temp1: TAG																	
; temp2: MONAT																	
; temp3: JAHR																	
; temp4: Wochentag (1..7														
RDS_DATUM:
	LDS temp3,(adr_RDS_BLOCK_BL)
	LDS temp2,(adr_RDS_BLOCK_CH)
	LDS temp1,(adr_RDS_BLOCK_CL)
	andi temp3,0b00011111
	LSR temp3
	ROR temp2
	ROR temp1
;	ldi temp1,BYTE1(TZ)	; Testzahlen
;	ldi temp2,BYTE2(TZ)
;	ldi temp3,BYTE3(TZ)

	STS(adr_RDS_DATUM0),temp1
	STS(adr_RDS_DATUM1),temp2
	STS(adr_RDS_DATUM2),temp3
	subi temp1, BYTE1(58484-1); 01.01.2019	
	sbci temp2, BYTE2(58484-1)
	sbci temp3, BYTE3(58484-1)
	mov ZL,temp1
	mov ZH,temp2
	STS(adr_DUMMY0),ZL
	STS(adr_DUMMY1),ZH



	ldi temp1,(1-1)	; TAG				
	ldi temp2,(1)	; MONAT				
	ldi temp3,(19)	; JAHR				
	ldi temp4,(2-1) ; Di (01.01.2019)	
	ldi temp9,31
;-------------------------------------------------------------------------------
RDS_DATUM_s:
	inc temp4
	cpi temp4,(7+1)
	brlo RDS_DATUM_w1
	ldi temp4,1
;-------------------------------------------------------------------------------
RDS_DATUM_w1:
	rcall RDS_TAGE
	inc temp1		; Tag + 1	
	cp  temp1,temp9
	brsh RDS_DATUM_w2
	rjmp RDS_DATUM_zz
;-------------------------------------------------------------------------------
RDS_DATUM_w2:
	ldi temp1,1		; Tag=1		
	inc temp2		; Monat +1	
	cpi temp2,12+1
	brsh RDS_DATUM_w3
	rjmp RDS_DATUM_zz
;-------------------------------------------------------------------------------
RDS_DATUM_w3:
	ldi temp2,1		; Monat=1	
	inc temp3		; Jahr + 1	
;-------------------------------------------------------------------------------
RDS_DATUM_zz:
	sbiw ZL,1		; Z-1		
	tst ZL
	brne RDS_DATUM_s
	tst ZH
	brne RDS_DATUM_s

	STS(adr_TAG),temp1
	STS(adr_MONAT),temp2
	STS(adr_JAHR),temp3
	STS(adr_WOCHENTAG),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_TAGE:
	cpi temp2,2	; Feb	
	breq RDS_TAGE_FEBRUAR
	cpi temp2,4	; April	
	breq RDS_TAGE_30
	cpi temp2,6	; Juni	
	breq RDS_TAGE_30
	cpi temp2,9	; Sept	
	breq RDS_TAGE_30
	cpi temp2,11; Nov	
	breq RDS_TAGE_30
	ldi temp9,31+1
	ret
RDS_TAGE_30:
	ldi temp9,30+1
	ret
RDS_TAGE_FEBRUAR:
	ldi temp9,28+1
	mov temp,temp3
	andi temp,0b00000011
	tst temp
	breq RDS_TAGE_FEBRUAR_SJ
	ret
RDS_TAGE_FEBRUAR_SJ:
	ldi temp9,29+1	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

