; #############################################################################
; #############################################################################
; #############################################################################
TFT_INITIALISIERUNG:
	; PIN initialisieren			
	cbi (TFT_DDR) ,(TFT_PIN_NR)
	sbi (TFT_PORT),(TFT_PIN_NR)
	; Helligkeit					
	ldi temp1,63
	rcall TFT_HELL_TEMP1	
	rcall TFT_BEEP
	; KURSOR off					
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_T
	rcall ASCII_C
	rcall ASCII_NULL	; NULL		
	; Tasten-Rahmentyp				
	rcall TASTEN_RAHMENTYP_DUNKEL
	call TFT_CLEAR
	call ANZEIGE_BEGRUESSUNG
	call PAKET_SENDEN
	call WAIT_1s
	ret
; #############################################################################
; #############################################################################
; #############################################################################
; komplett alles lschen (TEXT/GRAFIC/TASTEN)									
TFT_CLEAR:
	call TFT_TEXT_CLEAR
	call TFT_GRAFIC_CLEAR
	call TASTEN_CLEAR
	call GRAFIC_TASTEN_ABFRAGEN
ret
; #############################################################################
; #############################################################################
; #############################################################################
; nur den TEXT lschen															
TFT_TEXT_CLEAR:
	ldi temp,12			; FF=Formfeed
	rcall PAKET_DATA_TEMP
	rjmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
; nur GRAFIC lschen und TASTEN verbergen										
TFT_GRAFIC_CLEAR:
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_D
	rcall ASCII_L
	rjmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_HELL_TEMP1:
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_Y
	rcall ASCII_H
	mov temp,temp1
	rcall PAKET_DATA_TEMP
	rjmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_BEEP:
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_Y
	rcall ASCII_S
	ldi temp,2
	rcall PAKET_DATA_TEMP
	rjmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
; ESC G P x1 y1																   
TFT_PUNKT_TEMP1_2:
	push temp2			; temp2 sichern	
	push temp1			; temp1 sichern	
	rcall ASCII_ESC	; ESC senden	
	rcall ASCII_G
	rcall ASCII_P
	pop temp			; temp1(temp) wieder herstellen
	rcall PAKET_DATA_TEMP
	pop temp			; temp2(temp) wieder herstellen
	rcall PAKET_DATA_TEMP
	rjmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
; ESC G  D x1 y1 x2 y2														   
TFT_GERADE_TEMP1_4:
	push temp4			; temp4 sichern
	push temp3			; temp3 sichern
	push temp2			; temp2 sichern
	push temp1			; temp1 sichern
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_G
	rcall ASCII_D
	pop temp			; temp1(temp) wieder herstellen
	rcall PAKET_DATA_TEMP
	pop temp			; temp2(temp) wieder herstellen
	rcall PAKET_DATA_TEMP
	pop temp			; temp3(temp) wieder herstellen
	rcall PAKET_DATA_TEMP
	pop temp			; temp4(temp) wieder herstellen
	rcall PAKET_DATA_TEMP
	rjmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_POWER_DOWN:
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_P
	rcall ASCII_D
	rcall ASCII_NULL
	ldi temp,1		; n2=0: kein WakeUp per Touch; n2=1: WakeUp per Touch mglich
	rcall PAKET_DATA_TEMP
	rjmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
; Puffer mit DATENBYTES laden, wird per "PAKET_SENDEN" zum Display gesendet		
;																				
;	inp: temp																	
;																				
PAKET_DATA_TEMP:
	; Sicherungskopie	
	push ZL
	push ZH
	push temp
	push temp1
	; Z-ZEIGER			
	ldi ZL,LOW (adr_GRAFIC_PUFFER256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER256)
	; addieren			
	LDS temp1,(adr_GRAFIC_PUFFER_TX_ZEIGER)
	add ZL,temp1
	adc ZH,NULL
	; speichern nach Z	
	ST Z,temp
	; Zeiger speichern	
	inc temp1
	STS(adr_GRAFIC_PUFFER_TX_ZEIGER),temp1
	; Puffer zu voll ?	
	cpi temp1,(PUFFER_DISPLAY_MAX)
	brne PAKET_DATA_FERTIG
	; sofort leeren						
	call PAKET_SENDEN
PAKET_DATA_FERTIG:
	; wiederherstellen (sicherungskopie)
	pop temp1
	pop temp
	pop ZH
	pop ZL
ret
; #############################################################################
; #############################################################################
; #############################################################################
; komplettes Paket zum Display senden 											
;																				
; <DC1> <LEN> <DATA> <PS>														
;																				
; temp = Hilfsregister															
; temp1= Hilfsregister															
; temp8= Zeiger																	
; temp9= Prfsumme (PS)															
; ZL   = ZEIGER																	
; ZH   = ZEIGER																	
PAKET_SENDEN:
	; Daten vorhanden ? len = NULL ?
	LDS temp,(adr_GRAFIC_PUFFER_TX_ZEIGER)
	tst temp
	brne PAKET_SENDEN_RUN
	ret
;-----------------------------------------------------------------------------
PAKET_SENDEN_RUN:
	; sichern				
	push temp
	push temp1	; Hilfsregister	
	push temp2
	push temp3
	push temp4
	push temp5
	push temp6
	push temp7
	push temp8	; Schleife
	push temp9	; Hilfsregister	
	push ZL
	push ZH
;-----------------------------------------------------------------------------
PAKET_SENDEN_S:
	; TWI START				
	ldi temp1,(TWI_ADRESSE_DISPLAY)
	call TWI_MT_START_TEMP1
	WDR
	; <DC1>				
	ldi temp1,17			
	mov temp9,temp1						; PS				
	call TWI_MT_DATA_TEMP1				; DATA	
	; len				
	LDS temp1,(adr_GRAFIC_PUFFER_TX_ZEIGER)
	add temp9,temp1						; PS				
	call TWI_MT_DATA_TEMP1				; DATA	
	; Intialisierung	
	LDS temp8,(adr_GRAFIC_PUFFER_TX_ZEIGER)
	ldi ZL,LOW (adr_GRAFIC_PUFFER256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER256)
;-----------------------------------------------------------------------------
PAKET_SENDEN_D:
	LD temp1,Z+							; DATA	
	add temp9,temp1						; PS	
	call TWI_MT_DATA_TEMP1				; DATA	
	dec temp8
	brne PAKET_SENDEN_D
	; BCC (PRFSUMME)	
	mov temp1,temp9						; PS
	call TWI_MT_DATA_TEMP1				; DATA	
	call TWI_STOP
;-----------------------------------------------------------------------------
	; ANTWORT			
	call PAKET_ANTWORT_TEMP1
	cpi temp1,6
	breq PAKET_SENDEN_OK
;-----------------------------------------------------------------------------
	; ERROR				
	rjmp PAKET_SENDEN_S						; nochmal senden
;-----------------------------------------------------------------------------
PAKET_SENDEN_OK:
	; NULL				
	STS(adr_GRAFIC_PUFFER_TX_ZEIGER),NULL
	; wieder herstellen	
	pop ZH
	pop ZL
	pop temp9
	pop temp8
	pop temp7
	pop temp6
	pop temp5
	pop temp4
	pop temp3
	pop temp2
	pop temp1
	pop temp
	ret
; #############################################################################
; #############################################################################
; #############################################################################
; Inhalt DISPLAY-SENDEPUFFER anfordern											
; OUT: temp1(ANZAHL BYTES)+SRAM													
;																				
PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_TEMP1_SRAM:
	; PUFFER leeren		
	call PAKET_SENDEN
;-----------------------------------------------------------------------------
	; SRAM clear		
	STS(adr_GRAFIC_PUFFER256+0),NULL
	STS(adr_GRAFIC_PUFFER256+1),NULL
	STS(adr_GRAFIC_PUFFER256+2),NULL
	STS(adr_GRAFIC_PUFFER256+3),NULL
	; START				
	ldi temp1,(TWI_ADRESSE_DISPLAY)
	call TWI_MT_START_TEMP1
	; <DC2>				
	ldi temp1,18			
	mov temp9,temp1			; PS
	call TWI_MT_DATA_TEMP1				; DATA	
	; len				
	ldi temp1,1
	add temp9,temp1			; PS
	call TWI_MT_DATA_TEMP1				; DATA	
	; DATA				
	ldi temp1,'S'
	add temp9,temp1			; PS
	call TWI_MT_DATA_TEMP1				; DATA	
	; BCC (PRFSUMME)	
	mov temp1,temp9
	call TWI_MT_DATA_TEMP1				; DATA	
	call TWI_STOP
;-----------------------------------------------------------------------------
	; ANTWORT			
	call PAKET_ANTWORT_TEMP1
	cpi temp1,6
	breq PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_OK
;-----------------------------------------------------------------------------
	; ERROR				
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	rjmp PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_TEMP1_SRAM
;-----------------------------------------------------------------------------
PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_OK:
	ldi temp1,(TWI_ADRESSE_DISPLAY)
	call TWI_MR_START_TEMP1
	call TWI_MR_DATA_TEMP1	; <DC1>
	call TWI_MR_DATA_TEMP1	; <len>
	push temp1
	tst temp1
	breq PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_ENDE
	; Schleife		
	mov temp9,temp1
	; Z-ZEIGER		
	ldi ZL,LOW (adr_GRAFIC_PUFFER256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER256)
PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_S:
	call TWI_MR_DATA_TEMP1
	; im SRAM ablegen	
	ST Z+,temp1
	dec temp9
	brne PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_S
;-----------------------------------------------------------------------------
PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_ENDE:
	call TWI_MR_LAST_DATA_TEMP1	; PS
	call TWI_STOP
	pop temp1									; Anzahl Bytes	
ret
; #############################################################################
; #############################################################################
; #############################################################################
; Antwortbyte vom DISPLAY anfordern												
;																				
; OUT: temp1																	
;																			 	
PAKET_ANTWORT_TEMP1:
	; START				
	ldi temp1,(TWI_ADRESSE_DISPLAY)
	call TWI_MR_START_TEMP1
	; DATENBYTE abholen	
	call TWI_MR_LAST_DATA_TEMP1
	; STOPP				
	jmp TWI_STOP
;######################################################################## 
;######################################################################## 
;######################################################################## 
; z.B: "12"														  	  	  
ZAHL2_TEMP1:
	cpi temp1,99+1
	brlo ZAHL2_TEMP1_w
	call ASCII_FRAGEZEICHEN
	call ASCII_FRAGEZEICHEN
	jmp PAKET_SENDEN
;-----------------------------------------------------------------------
ZAHL2_TEMP1_w:
	clr temp2
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	mov temp, temp2				; 2.ZEICHEN 
	call PAKET_DATA_TEMP	
	mov temp, temp1				; 1.ZEICHEN 
	call PAKET_DATA_TEMP
	jmp PAKET_SENDEN
;######################################################################## 
;######################################################################## 
;######################################################################## 
; "123"														  	  	      
ZAHL_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	call FUNKTION_FORMAT
	rjmp STELLEN3
;######################################################################## 
;######################################################################## 
;######################################################################## 
; "12.345"														  	  	  
ZAHL_TEMP1_2:
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	call FUNKTION_FORMAT
	rjmp STELLEN6
;######################################################################## 
;######################################################################## 
;######################################################################## 
; "1234"														  	  	  
ZAHL4_TEMP1_2:
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	rjmp STELLEN4
;######################################################################## 
;######################################################################## 
;######################################################################## 
ZAHL_TEMP1_2_3:
	clr temp4
	call FUNKTION_HEX_ASC_32
	call FUNKTION_FORMAT
	rjmp STELLEN13
;######################################################################## 
;######################################################################## 
;######################################################################## 
; "4.294.967.295"														  
ZAHL_TEMP1_2_3_4:
	call FUNKTION_HEX_ASC_32
	call FUNKTION_FORMAT
	rjmp STELLEN13
;######################################################################## 
;######################################################################## 
;######################################################################## 
; "123,45"														  	  	  
ZAHL5_KOMMA2_TEMP1_2:
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	cpi temp5,'0'
	brne ZAHL5_KOMMA2_TEMP1_2_w6
;-----------------------------------------------------------------------
ZAHL5_KOMMA2_TEMP1_2_w5:
	mov temp5,temp4
	mov temp4,temp3
	ldi temp3,','
	call STELLEN5
	jmp ASCII_SPACE
;-----------------------------------------------------------------------
ZAHL5_KOMMA2_TEMP1_2_w6:
	mov temp6,temp5
	mov temp5,temp4
	mov temp4,temp3
	ldi temp3,','
	rjmp STELLEN6
;######################################################################## 
;######################################################################## 
;######################################################################## 
; 1234567890"															  
ZAHL10_TEMP1_2_3_4:
	call FUNKTION_HEX_ASC_32
	cpi XL,'0'
	brne ZAHL10
	ldi XL,'_'
	cpi temp9,'0'
	brne ZAHL10
	ldi temp9,'_'
	cpi temp8,'0'
	brne ZAHL10
	ldi temp8,'_'
	cpi temp7,'0'
	brne ZAHL10
	ldi temp7,'_'
	cpi temp6,'0'
	brne ZAHL10
	ldi temp6,'_'
	cpi temp5,'0'
	brne ZAHL10
	ldi temp5,'_'
	cpi temp4,'0'
	brne ZAHL10
	ldi temp4,'_'
	cpi temp3,'0'
	brne ZAHL10
	ldi temp3,'_'
	cpi temp2,'0'
	brne ZAHL10
	ldi temp2,'_'
	cpi temp1,'0'
	brne ZAHL10
	ldi temp1,'_'
;-------------------------------------------------------------------------------
ZAHL10:
	mov temp, XL			; 10
	call PAKET_DATA_TEMP
	mov temp, temp9			; 9
	call PAKET_DATA_TEMP
	mov temp, temp8			; 8
	call PAKET_DATA_TEMP	
	mov temp, temp7			; 7
	call PAKET_DATA_TEMP	
	mov temp, temp6			; 6
	call PAKET_DATA_TEMP	
	mov temp, temp5			; 5
	call PAKET_DATA_TEMP	
	mov temp, temp4			; 4
	call PAKET_DATA_TEMP	
	mov temp, temp3			; 3
	call PAKET_DATA_TEMP	
	mov temp, temp2			; 2
	call PAKET_DATA_TEMP	
	mov temp, temp1			;1-er Stelle
	call PAKET_DATA_TEMP
	call ASCII_SPACE
	rjmp PAKET_SENDEN
;######################################################################## 
;######################################################################## 
;######################################################################## 
STELLEN13:
	mov temp, YH			; 11.ZEICHEN 
	call PAKET_DATA_TEMP
STELLEN12:
	mov temp, YL			; 11.ZEICHEN 
	call PAKET_DATA_TEMP
STELLEN11:
	mov temp, XH			; 11.ZEICHEN 
	call PAKET_DATA_TEMP
STELLEN10:
	mov temp, XL			; 10.ZEICHEN 
	call PAKET_DATA_TEMP
STELLEN9:
	mov temp, temp9			; 9.ZEICHEN 
	call PAKET_DATA_TEMP
STELLEN8:
	mov temp, temp8			; 8.ZEICHEN 
	call PAKET_DATA_TEMP	
STELLEN7:
	mov temp, temp7			; 7.ZEICHEN 
	call PAKET_DATA_TEMP	
STELLEN6:
	mov temp, temp6			; 6.ZEICHEN 
	call PAKET_DATA_TEMP	
STELLEN5:
	mov temp, temp5			; 5.ZEICHEN 
	call PAKET_DATA_TEMP	
STELLEN4:
	mov temp, temp4			; 4.ZEICHEN 
	call PAKET_DATA_TEMP	
STELLEN3:
	mov temp, temp3			; 3.ZEICHEN 
	call PAKET_DATA_TEMP	
STELLEN2:
	mov temp, temp2			; 2.ZEICHEN 
	call PAKET_DATA_TEMP	
STELLEN1:
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	call PAKET_DATA_TEMP
	call ASCII_SPACE
	jmp PAKET_SENDEN
;######################################################################## 	
;######################################################################## 	
;######################################################################## 	
; formatiert die LCD AUSGABE mit 1000-er Punkt								
; 	Bsp. "00012345 => "1.234.567.890"										
;	INPUT: TEMP1															
;	INPUT: TEMP2															
;	INPUT: TEMP3															
;	INPUT: TEMP4															
;	INPUT: TEMP5															
;	INPUT: TEMP6															
;	INPUT: TEMP7															
;	INPUT: TEMP8															
;	INPUT: TEMP9															
;	INPUT: XL																
;																			
;	OUPUT: TEMP1															
;	OUPUT: TEMP2															
;	OUPUT: TEMP3															
;	OUPUT: TEMP4															
;	OUPUT: TEMP5															
;	OUPUT: TEMP6															
;	OUPUT: TEMP7															
;	OUPUT: TEMP8															
;	OUPUT: TEMP9															
;	OUPUT: XL																
;	OUPUT: XH																
;	OUPUT: YL																
;	OUPUT: YH																
FUNKTION_FORMAT:
	; zuordnen			
	mov YH,XL
	ldi YL,'.'
	mov XH,temp9
	mov XL,temp8
	mov temp9,temp7
	ldi temp8,'.'
	mov temp7,temp6
	mov temp6,temp5
	mov temp5,temp4
	ldi temp4,'.'
	; vergleich/ersetzen		
	cpi YH,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi YH,'_'
	ldi YL,'_'
	; vergleich/ersetzen		
	cpi XH,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi XH,'_'
	; vergleich/ersetzen		
	cpi XL,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi XL,'_'
	; vergleich/ersetzen		
	cpi temp9,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp9,'_'
	ldi temp8,'_'
	; vergleich/ersetzen		
	cpi temp7,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp7,'_'
	; vergleich/ersetzen		
	cpi temp6,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp6,'_'
	; vergleich/ersetzen		
	cpi temp5,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp5,'_'
	ldi temp4,'_'
	; vergleich/ersetzen		
	cpi temp3,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp3,'_'
	; vergleich/ersetzen		
	cpi temp2,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp2,'_'
	; vergleich/ersetzen		
	cpi temp1,'0'
	brne FUNKTION_FORMAT_FERTIG
	ldi temp1,'0'
FUNKTION_FORMAT_FERTIG:
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; STAND: 09.12.2011															
;																			
;	Value: 0...	4.294.967.295												
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		     1-er Stelle)								
;			temp2	(		    10-er Stelle)								
;			temp3	(          100-er Stelle)								
;			temp4	(        1.000-er Stelle)								
;			temp5	(       10.000-er Stelle)								
;			temp6	(      100.000-er Stelle)								
;			temp7	(    1.000.000-er Stelle)								
;			temp8	(   10.000.000-er Stelle)								
;			temp9	(  100.000.000-er Stelle)								
;			XL		(1.000.000.000-er Stelle)								
; 																			
FUNKTION_HEX_ASC_32:
	clr XL
FUNKTION_HEX_ASC_109:	; 1.000.000.000
	inc XL
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNKTION_HEX_ASC_109
	subi XL, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)
;---------------------------------------------------------------------------
	clr temp9			
FUNKTION_HEX_ASC_108:	; 100.000.000
	inc temp9
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNKTION_HEX_ASC_108
	subi temp9, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
;---------------------------------------------------------------------------
	clr temp8
FUNKTION_HEX_ASC_107:	; 10.000.000
	inc temp8
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_107
	subi temp8, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
;---------------------------------------------------------------------------
	clr temp7
FUNKTION_HEX_ASC_106:	; 1.000.000
	inc temp7
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_106
	subi temp7, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
;---------------------------------------------------------------------------
	clr temp6
FUNKTION_HEX_ASC_105:	; 100.000	
	inc temp6
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_105
	subi temp6, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
;---------------------------------------------------------------------------	clr temp
	clr temp5
FUNKTION_HEX_ASC_104:	; 10.000	
	inc temp5
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_104
	subi temp5, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
;---------------------------------------------------------------------------
	clr temp4
FUNKTION_HEX_ASC_103:	; 1.000		
	inc temp4
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_103
	subi temp4, (-48+1)	; HEX->ASC	
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
;---------------------------------------------------------------------------
	clr temp3
FUNKTION_HEX_ASC_102:	; 100		
	inc temp3
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_102
	subi temp3, (-48+1)	; HEX->ASC	
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
;---------------------------------------------------------------------------
	clr temp2
FUNKTION_HEX_ASC_101:	; 10		
	inc temp2
	subi temp1, low  (10)
	brcc FUNKTION_HEX_ASC_101
	subi temp2, (-48+1)	; HEX->ASC	
	subi temp1, low  (-10)
;---------------------------------------------------------------------------
FUNKTION_HEX_ASC_100:	; 1			
	subi temp1, -48		; HEX->ASC	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; INP: temp																	
; OUT: (z.B."FF") 															
;																			
ZAHL_HEX_TEMP1:
	push temp1				; SICHERUNGSKOPIE	
	push temp1				; SICHERUNGSKOPIE	
	mov temp,temp1			; KOPIE				
	; oberes NIBBLE bearbeiten					
	swap temp				; NIBBLES tausch	
	call ZAHL_HEX_NIBBLE	; INP/OUT: temp		
	call PAKET_DATA_TEMP
	; unteres NIBBLE bearbeiten					
	pop temp1				; Wiederherstellen	
	mov temp,temp1	
	call ZAHL_HEX_NIBBLE	; INP/OUT: temp		
	call PAKET_DATA_TEMP
	call PAKET_SENDEN
	pop temp1				; Wiederherstellen	
ret
;-------------------------------------------------------------------------------
ZAHL_HEX_NIBBLE:
	andi temp,0b00001111	; BITMUSTER	
	cpi temp,10				; vergleich	
	brsh ZAHL_HEX_NIBBLE_A_F
	subi temp,-48
	ret
ZAHL_HEX_NIBBLE_A_F:
	subi temp,-48-7
	ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	

; #############################################################################
; #############################################################################
; #############################################################################
ZEILE1:
	ldi temp,1	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE2:
	ldi temp,2	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE3:
	ldi temp,3	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE4:
	ldi temp,4	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE5:
	ldi temp,5	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE6:
	ldi temp,6	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE7:
	ldi temp,7	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE8:
	ldi temp,8	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE9:
	ldi temp,9	; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE10:
	ldi temp,10; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE11:
	ldi temp,11; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE12:
	ldi temp,12; ZEILE		
	rjmp GRAFIC_ZEILE
ZEILE13:
	ldi temp,13; ZEILE		
	rjmp GRAFIC_ZEILE
; #############################################################################
GRAFIC_ZEILE:
	push temp
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_T
	rcall ASCII_P
	rcall ASCII_EINS	; SPALTE(1)	
	pop temp			; ZEILE		
	rjmp PAKET_DATA_TEMP
; #############################################################################
; #############################################################################
; #############################################################################
ZEILE1_CLEAR:
	call ZEILE1
	rjmp ZEILE_CLEAR
ZEILE2_CLEAR:
	call ZEILE2
	rjmp ZEILE_CLEAR
ZEILE3_CLEAR:
	call ZEILE3
	rjmp ZEILE_CLEAR
ZEILE4_CLEAR:
	call ZEILE4
	rjmp ZEILE_CLEAR
ZEILE5_CLEAR:
	call ZEILE5
	rjmp ZEILE_CLEAR
ZEILE6_CLEAR:
	call ZEILE6
	rjmp ZEILE_CLEAR
ZEILE7_CLEAR:
	call ZEILE7
	rjmp ZEILE_CLEAR
ZEILE8_CLEAR:
	call ZEILE8
	rjmp ZEILE_CLEAR
ZEILE9_CLEAR:
	call ZEILE9
	rjmp ZEILE_CLEAR
ZEILE10_CLEAR:
	call ZEILE10
	rjmp ZEILE_CLEAR
ZEILE11_CLEAR:
	call ZEILE11
	rjmp ZEILE_CLEAR
ZEILE12_CLEAR:
	call ZEILE12
	rjmp ZEILE_CLEAR
ZEILE13_CLEAR:
	call ZEILE13
	rjmp ZEILE_CLEAR
ZEILE_CLEAR:
	call ASCII_SPACE5
	call ASCII_SPACE5
	call ASCII_SPACE5
	call ASCII_SPACE5
	jmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
ASCII_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ASCII_TEXT_Z_w 	; Sprung
	rcall PAKET_SENDEN
	ret
ASCII_TEXT_Z_w:
	rcall PAKET_DATA_TEMP
	rjmp ASCII_TEXT_Z
; #############################################################################
ASCII_0:
	ldi temp,'0'
	rjmp PAKET_DATA_TEMP
ASCII_1:
	ldi temp,'1'
	rjmp PAKET_DATA_TEMP
ASCII_2:
	ldi temp,'2'
	rjmp PAKET_DATA_TEMP
ASCII_3:
	ldi temp,'3'
	rjmp PAKET_DATA_TEMP
ASCII_4:
	ldi temp,'4'
	rjmp PAKET_DATA_TEMP
ASCII_5:
	ldi temp,'5'
	rjmp PAKET_DATA_TEMP
ASCII_6:
	ldi temp,'6'
	rjmp PAKET_DATA_TEMP
ASCII_7:
	ldi temp,'7'
	rjmp PAKET_DATA_TEMP
ASCII_8:
	ldi temp,'8'
	rjmp PAKET_DATA_TEMP
ASCII_9:
	ldi temp,'9'
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_ESC:
	ldi temp,27
	rjmp PAKET_DATA_TEMP
ASCII_NULL:
	clr temp
	rjmp PAKET_DATA_TEMP
ASCII_EINS:
	ldi temp,1
	rjmp PAKET_DATA_TEMP
ASCII_ZWEI:
	ldi temp,2
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_SPACE9:
	ldi temp,' ' ; SPACE
	rcall PAKET_DATA_TEMP
ASCII_SPACE8:
	ldi temp,' ' ; SPACE
	rcall PAKET_DATA_TEMP
ASCII_SPACE7:
	ldi temp,' ' ; SPACE
	rcall PAKET_DATA_TEMP
ASCII_SPACE6:
	ldi temp,' ' ; SPACE
	rcall PAKET_DATA_TEMP
ASCII_SPACE5:
	ldi temp,' ' ; SPACE
	rcall PAKET_DATA_TEMP
ASCII_SPACE4:
	ldi temp,' ' ; SPACE
	rcall PAKET_DATA_TEMP
ASCII_SPACE3:
	ldi temp,' ' ; SPACE
	rcall PAKET_DATA_TEMP
ASCII_SPACE2:
	ldi temp,' ' ; SPACE
	rcall PAKET_DATA_TEMP
ASCII_SPACE:
	ldi temp,' ' ; SPACE
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_UNTERSTRICH10:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH9:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH8:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH7:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH6:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH5:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH4:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH3:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH2:
	ldi temp,'_' ; "_"
	rcall PAKET_DATA_TEMP
ASCII_UNTERSTRICH:
	ldi temp,'_' ; "_"
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_MINUS9:
	ldi temp,'-'
	rcall PAKET_DATA_TEMP
ASCII_MINUS8:
	ldi temp,'-'
	rcall PAKET_DATA_TEMP
ASCII_MINUS7:
	ldi temp,'-'
	rcall PAKET_DATA_TEMP
ASCII_MINUS6:
	ldi temp,'-'
	rcall PAKET_DATA_TEMP
ASCII_MINUS5:
	ldi temp,'-'
	rcall PAKET_DATA_TEMP
ASCII_MINUS4:
	ldi temp,'-'
	rcall PAKET_DATA_TEMP
ASCII_MINUS3:
	ldi temp,'-'
	rcall PAKET_DATA_TEMP
ASCII_MINUS2:
	ldi temp,'-'
	rcall PAKET_DATA_TEMP
ASCII_MINUS:
	ldi temp,'-'
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_PUNKT5:
	ldi temp,'.' ; "."
	rcall PAKET_DATA_TEMP
ASCII_PUNKT4:
	ldi temp,'.' ; "."
	rcall PAKET_DATA_TEMP
ASCII_PUNKT3:
	ldi temp,'.' ; "."
	rcall PAKET_DATA_TEMP
ASCII_PUNKT2:
	ldi temp,'.' ; "."
	rcall PAKET_DATA_TEMP
ASCII_PUNKT:
	ldi temp,'.' ; "."
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_DOPPEL_PUNKT:
	ldi temp,':' ; ":"
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_ISTGLEICH:
	ldi temp,'=' ; "="
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_PROZENT:
	ldi temp,'%'
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_SCHRAEGSTRICH:
	ldi temp,'/'
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_FRAGEZEICHEN:
	ldi temp,'?' 
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_AUSRUFEZEICHEN:
	ldi temp,'!' 
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_GAENSEFUESSCHEN:
	ldi temp,'"' 
	rjmp PAKET_DATA_TEMP
; #############################################################################
ASCII_DOPPELPUNKT:
	ldi temp,':' 
	rjmp PAKET_DATA_TEMP
; #############################################################################
; #############################################################################
; #############################################################################
ASCII_A:
	ldi temp,'A' 
	rjmp PAKET_DATA_TEMP
ASCII_B:
	ldi temp,'B' 
	rjmp PAKET_DATA_TEMP
ASCII_C:
	ldi temp,'C' 
	rjmp PAKET_DATA_TEMP
ASCII_D:
	ldi temp,'D' 
	rjmp PAKET_DATA_TEMP
ASCII_E:
	ldi temp,'E' 
	rjmp PAKET_DATA_TEMP
ASCII_F:
	ldi temp,'F' 
	rjmp PAKET_DATA_TEMP
ASCII_G:
	ldi temp,'G' 
	rjmp PAKET_DATA_TEMP
ASCII_H:
	ldi temp,'H' 
	rjmp PAKET_DATA_TEMP
ASCII_I:
	ldi temp,'I' 
	rjmp PAKET_DATA_TEMP
ASCII_J:
	ldi temp,'J' 
	rjmp PAKET_DATA_TEMP
ASCII_K:
	ldi temp,'K' 
	rjmp PAKET_DATA_TEMP
ASCII_L:
	ldi temp,'L' 
	rjmp PAKET_DATA_TEMP
ASCII_M:
	ldi temp,'M' 
	rjmp PAKET_DATA_TEMP
ASCII_N:
	ldi temp,'N' 
	rjmp PAKET_DATA_TEMP
ASCII_O:
	ldi temp,'O' 
	rjmp PAKET_DATA_TEMP
ASCII_P:
	ldi temp,'P' 
	rjmp PAKET_DATA_TEMP
ASCII_Q:
	ldi temp,'Q' 
	rjmp PAKET_DATA_TEMP
ASCII_R:
	ldi temp,'R' 
	rjmp PAKET_DATA_TEMP
ASCII_S:
	ldi temp,'S' 
	rjmp PAKET_DATA_TEMP
ASCII_T:
	ldi temp,'T' 
	rjmp PAKET_DATA_TEMP
ASCII_U:
	ldi temp,'U' 
	rjmp PAKET_DATA_TEMP
ASCII_V:
	ldi temp,'V' 
	rjmp PAKET_DATA_TEMP
ASCII_W:
	ldi temp,'W' 
	rjmp PAKET_DATA_TEMP
ASCII_X:
	ldi temp,'X' 
	rjmp PAKET_DATA_TEMP
ASCII_Y:
	ldi temp,'Y' 
	rjmp PAKET_DATA_TEMP
ASCII_Z:
	ldi temp,'Z' 
	rjmp PAKET_DATA_TEMP
; #############################################################################
; #############################################################################
; #############################################################################
ASCII_a_:
	ldi temp,'a' 
	rjmp PAKET_DATA_TEMP
ASCII_b_:
	ldi temp,'b' 
	rjmp PAKET_DATA_TEMP
ASCII_c_:
	ldi temp,'c' 
	rjmp PAKET_DATA_TEMP
ASCII_d_:
	ldi temp,'d' 
	rjmp PAKET_DATA_TEMP
ASCII_e_:
	ldi temp,'e' 
	rjmp PAKET_DATA_TEMP
ASCII_f_:
	ldi temp,'f' 
	rjmp PAKET_DATA_TEMP
ASCII_g_:
	ldi temp,'g' 
	rjmp PAKET_DATA_TEMP
ASCII_h_:
	ldi temp,'h' 
	rjmp PAKET_DATA_TEMP
ASCII_i_:
	ldi temp,'i' 
	rjmp PAKET_DATA_TEMP
ASCII_j_:
	ldi temp,'j' 
	rjmp PAKET_DATA_TEMP
ASCII_k_:
	ldi temp,'k' 
	rjmp PAKET_DATA_TEMP
ASCII_l_:
	ldi temp,'l' 
	rjmp PAKET_DATA_TEMP
ASCII_m_:
	ldi temp,'m' 
	rjmp PAKET_DATA_TEMP
ASCII_n_:
	ldi temp,'n' 
	rjmp PAKET_DATA_TEMP
ASCII_o_:
	ldi temp,'o' 
	rjmp PAKET_DATA_TEMP
ASCII_p_:
	ldi temp,'p' 
	rjmp PAKET_DATA_TEMP
ASCII_q_:
	ldi temp,'q' 
	rjmp PAKET_DATA_TEMP
ASCII_r_:
	ldi temp,'r' 
	rjmp PAKET_DATA_TEMP
ASCII_s_:
	ldi temp,'s' 
	rjmp PAKET_DATA_TEMP
ASCII_t_:
	ldi temp,'t' 
	rjmp PAKET_DATA_TEMP
ASCII_u_:
	ldi temp,'u' 
	rjmp PAKET_DATA_TEMP
ASCII_v_:
	ldi temp,'v' 
	rjmp PAKET_DATA_TEMP
ASCII_w_:
	ldi temp,'w' 
	rjmp PAKET_DATA_TEMP
ASCII_x_:
	ldi temp,'x' 
	rjmp PAKET_DATA_TEMP
ASCII_Y_:
	ldi temp,'y' 
	rjmp PAKET_DATA_TEMP
ASCII_z_:
	ldi temp,'z' 
	rjmp PAKET_DATA_TEMP






