; ##############################################################################
; ##############################################################################
; ##############################################################################
; 8-BIT-TIMER																	
;																				
; CS02 CS01 CS00																
;	0 	0	0 	No clock source (Timer/Counter stopped)							
; *	0 	0 	1 	clkI/O/(No prescaling)											
;	0 	1 	0 	clkI/O/8 (From prescaler)										
;	0 	1 	1 	clkI/O/64 (From prescaler)										
;	1 	0 	0 	clkI/O/256 (From prescaler)										
;	1 	0 	1 	clkI/O/1024 (From prescaler)									
;	1 	1 	0 	External clock source on T0 pin. Clock on falling edge.			
;	1 	1 	1 	External clock source on T0 pin. Clock on rising edge.			
;																				
; Mode WGM2 WGM1 WGM0 	Mode 													
; 	0 	0 	0 	 0 		Normal 													
; 	1 	0 	0 	 1 		PWM														
; 	2 	0 	1 	 0 		CTC														
; *	3 	0 	1 	 1 		Fast													
; 	5 	1 	0 	 1 		PWM														
; 	7 	1 	1 	 1 		Fast PWM												
;																				
TIMER0_INITIALISIERUNG_PWM8:
	; TCCR0A  Timer/Counter Control Register A		
	ldi temp, (1<<COM0A1)| (0<<COM0A0)|(1<<COM0B1)|(0<<COM0B0)|(0<<WGM01)|(1<<WGM00)
	OUT TCCR0A,temp
	; TCCR0B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC0A)| (0<<FOC0B)|(0<<WGM02)|(0<<CS02)|(0<<CS01)|(1<<CS00)
	OUT TCCR0B,temp
	; TIMSK0  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE0B)| (0<<OCIE0A)|(0<<TOIE0)
	STS TIMSK0,temp
	; OCR0A  Output Compare Register A				
	ldi temp,255/2
	OUT OCR0A,temp
	OUT OCR0B,temp
	; auf AUSGANG									
	sbi DDRB,PB3	; PIN OC0A
	sbi DDRB,PB4	; PIN OC0B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CS12 CS11 CS10																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
;   0 	0 	1 	clkI/1 (No prescaling)											
; 	0 	1 	0 	clkI/8 (From prescaler)											
; 	0 	1 	1 	clkI/64 (From prescaler)										
; 	1 	0 	0 	clkI/256 (From prescaler)										
; 	1 	0 	1 	clkI/1024 (From prescaler)										
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
;Mod WGM13 WGM12 WGM11 WGM10 													
;0 		0 	0 	0 	0 			Normal 0xFFFF Immediate MAX						
;1 		0 	0 	0 	1 			PWM, Phase Correct, 8-bit 0x00FF TOP BOTTOM		
;2 		0 	0 	1 	0 			PWM, Phase Correct, 9-bit 0x01FF TOP BOTTOM		
;3 		0 	0 	1 	1 			PWM, Phase Correct, 10-bit 0x03FF TOP BOTTOM	
;4 		0 	1 	0 	0 			CTC OCRnA Immediate MAX							
;5 		0 	1 	0 	1 			Fast PWM, 8-bit 0x00FF BOTTOM TOP				
;6 		0 	1 	1 	0 			Fast PWM, 9-bit 0x01FF BOTTOM TOP				
;7 		0 	1 	1 	1 			Fast PWM, 10-bit 0x03FF BOTTOM TOP				
;8 		1 	0 	0 	0 			PWM, Phase and Frequency Correct ICRn BOTTOM BOTTOM
;9 		1 	0 	0 	1 			PWM, Phase and Frequency Correct OCRnA BOTTOM BOTTOM
;10 	1 	0 	1 	0 			PWM, Phase Correct ICRn TOP BOTTOM				
;11 	1 	0 	1 	1 			PWM, Phase Correct OCRnA TOP BOTTOM				
;12 	1 	1 	0 	0 			CTC ICRn Immediate MAX							
;13 	1 	1 	0 	1 			(Reserved)   								
;14    *1 	1 	1 	0 			Fast PWM ICRn BOTTOM TOP						
;15 	1 	1 	1 	1 			Fast PWM OCRnA BOTTOM TOP						
TIMER1_INITIALISIERUNG_PWM16:
	; TCCR1A  Control Register A			
	ldi temp, (1<<COM1A1)| (0<<COM1A0)|(1<<COM1B1)|(0<<COM1B0)|(1<<WGM11)|(0<<WGM10)
	STS TCCR1A,temp
	; TCCR1B  Control Register B			
	ldi temp, (0<<ICNC1)| (0<<ICES1)|(1<<WGM13)|(1<<WGM12)|(0<<CS12)|(0<<CS11)|(1<<CS10)
	STS TCCR1B,temp
	; TCCR1C  Control Register C			
	ldi temp, (0<<FOC1A)|(0<<FOC1B)
	STS TCCR1C,temp
	; TIMSK1  Interrupt Mask Register		
	ldi temp, (0<<ICIE1)| (0<<OCIE1B)|(0<<OCIE1A)|(0<<TOIE1)
	STS TIMSK1,temp
	; ICR1 	 Input Capture Register 		
.equ ICR1=255
	ldi temp1,LOW (ICR1)
	ldi temp2,HIGH(ICR1)
	STS ICR1H,temp2		; zuerst high	
	STS ICR1L,temp1		; dann low		
	; OCR1A  Output Compare Register 1 A	
	ldi temp1,LOW (127)
	ldi temp2,HIGH(127)
	STS OCR1AH,temp2
	STS OCR1AL,temp1
	; OCR1B  Output Compare Register 1 A	
	ldi temp1,LOW (127)
	ldi temp2,HIGH(127)
	STS OCR1BH,temp2
	STS OCR1BL,temp1
	; auf AUSGANG											
	sbi DDRD, PD5		; OC1A
	sbi DDRD, PD4		; OC1B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 8-BIT-TIMER																	
;																				
; CS22 CS21 CS20 Description													
;	0 	0 	0 	No clock source (Timer/Counter stopped).						
;	0 	0 	1 	clkT2S/(No prescaling)											
;	0 	1 	0 	clkT2S/8 (From prescaler)										
;	0 	1 	1 	clkT2S/32 (From prescaler)										
;	1 	0 	0 	clkT2S/64 (From prescaler)										
;	1 	0 	1 	clkT2S/128 (From prescaler)										
;	1 	1 	0 	clkT2S/256 (From prescaler)										
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
;																				
; Mode WGM2 WGM1 WGM0 	Mode 													
; 	0 	0 	0 	 0 		Normal 													
; 	1 	0 	0 	 1 		PWM														
; 	2 	0 	1 	 0 		CTC														
; *	3 	0 	1 	 1 		Fast													
; 	5 	1 	0 	 1 		PWM														
; 	7 	1 	1 	 1 		Fast PWM												
;																				
; PWM NF / Analoginstrument														
TIMER2_INITIALISIERUNG_PWM8:
	; TCCR2A  Timer/Counter Control Register A		
	ldi temp, (1<<COM2A1)| (0<<COM2A0)|(1<<COM2B1)|(0<<COM2B0)|(1<<WGM21)|(1<<WGM20)
	STS TCCR2A,temp
	; TCCR2B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC2A)| (0<<FOC2B)|(0<<WGM22)|(0<<CS22)|(0<<CS21)|(1<<CS20)
	STS TCCR2B,temp
	; TIMSK2  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE2B)| (0<<OCIE2A)|(0<<TOIE2)
	STS TIMSK2,temp
	; OCR2A  Output Compare Register A				
	ldi temp,255/2
	STS PWM_NF,temp 	; STS OCR2A,temp	
	; OCR2B  Output Compare Register B				
	ldi temp,255
	STS PWM_ZEIG,temp	; STS OCR2B,temp	
	; auf AUSGANG									
	sbi DDRD,PD6	; PIN OC2B	
	sbi DDRD,PD7	; PIN OC2A	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CS32 CS31 CS30																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
;   0 	0 	1 	clkI/1 (No prescaling)											
; 	0 	1 	0 	clkI/8 (From prescaler)											
; 	0 	1 	1 	clkI/64 (From prescaler)										
; 	1 	0 	0 	clkI/256 (From prescaler)										
; 	1 	0 	1 	clkI/1024 (From prescaler)										
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
;Mod WGM33 WGM32 WGM31 WGM30 													
;0 		0 	0 	0 	0 			Normal 0xFFFF Immediate MAX						
;1 		0 	0 	0 	1 			PWM, Phase Correct, 8-bit 0x00FF TOP BOTTOM		
;2 		0 	0 	1 	0 			PWM, Phase Correct, 9-bit 0x01FF TOP BOTTOM		
;3 		0 	0 	1 	1 			PWM, Phase Correct, 10-bit 0x03FF TOP BOTTOM	
;4 		0 	1 	0 	0 			CTC OCRnA Immediate MAX							
;5 		0 	1 	0 	1 			Fast PWM, 8-bit 0x00FF BOTTOM TOP				
;6 		0 	1 	1 	0 			Fast PWM, 9-bit 0x01FF BOTTOM TOP				
;7 		0 	1 	1 	1 			Fast PWM, 10-bit 0x03FF BOTTOM TOP				
;8 		1 	0 	0 	0 			PWM, Phase and Frequency Correct ICRn BOTTOM BOTTOM
;9 		1 	0 	0 	1 			PWM, Phase and Frequency Correct OCRnA BOTTOM BOTTOM
;10 	1 	0 	1 	0 			PWM, Phase Correct ICRn TOP BOTTOM				
;11 	1 	0 	1 	1 			PWM, Phase Correct OCRnA TOP BOTTOM				
;12 	1 	1 	0 	0 			CTC ICRn Immediate MAX							
;13 	1 	1 	0 	1 			(Reserved)   								
;14    *1 	1 	1 	0 			Fast PWM ICRn BOTTOM TOP						
;15 	1 	1 	1 	1 			Fast PWM OCRnA BOTTOM TOP						
TIMER3_INITIALISIERUNG_PWM16:
	; TCCR1A  Control Register A			
	ldi temp, (1<<COM3A1)| (0<<COM3A0)|(1<<COM3B1)|(0<<COM3B0)|(1<<WGM31)|(0<<WGM30)
	STS TCCR3A,temp
	; TCCR1B  Control Register B			
	ldi temp, (0<<ICNC3)| (0<<ICES3)|(1<<WGM33)|(1<<WGM32)|(0<<CS32)|(0<<CS31)|(1<<CS30)
	STS TCCR3B,temp
	; TCCR3C  Control Register C			
	ldi temp, (0<<FOC3A)|(0<<FOC3B)
	STS TCCR3C,temp
	; TIMSK3  Interrupt Mask Register		
	ldi temp, (0<<ICIE3)| (0<<OCIE3B)|(0<<OCIE3A)|(0<<TOIE3)
	STS TIMSK3,temp
	; ICR1 	 Input Capture Register 		
.equ ICR3=255
	ldi temp1,LOW (ICR3)
	ldi temp2,HIGH(ICR3)
	STS ICR3H,temp2		; zuerst high	
	STS ICR3L,temp1		; dann low		
	; OCR1A  Output Compare Register 1 A	
	ldi temp1,LOW (127)
	ldi temp2,HIGH(127)
	STS OCR3AH,temp2
	STS OCR3AL,temp1
	; OCR1B  Output Compare Register 1 A	
	ldi temp1,LOW (127)
	ldi temp2,HIGH(127)
	STS OCR3BH,temp2
	STS OCR3BL,temp1
	; auf AUSGANG											
	sbi DDRB, PB6; OC3A
	sbi DDRB, PB7; OC3B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CS32 CS31 CS30																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
;   0 	0 	1 	clkI/1 (No prescaling)											
; 	0 	1 	0 	clkI/8 (From prescaler)											
; *	0 	1 	1 	clkI/64 (From prescaler)										
; 	1 	0 	0 	clkI/256 (From prescaler)										
; 	1 	0 	1 	clkI/1024 (From prescaler)										
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
TIMER3_INITIALISIERUNG_UHR:
; 22.000.000:64=343.750 :10 =34.375
.equ TIM3WERT=65535-34375
	; TCCR3A  Timer/Counter 3 Control Register A			
	ldi temp, (0<<COM3A1)| (0<<COM3A0)|(0<<COM3B1)|(0<<COM3B0)|(0<<WGM31)|(0<<WGM30)
	STS TCCR3A,temp
	; TCCR3B  Timer/Counter 3 Control Register B			
	ldi temp, (0<<ICNC3)| (0<<ICES3)|(0<<WGM33)|(0<<WGM32)|(0<<CS32)|(1<<CS31)|(1<<CS30)
	STS TCCR3B,temp
	; TCCR3C  Timer/Counter 3 Control Register C			
	ldi temp, (0<<FOC3A)|(0<<FOC3B)
	STS TCCR3C,temp
	; TIMSK3  Timer/Counter3 Interrupt Mask Register		
	ldi temp, (0<<ICIE3)| (0<<OCIE3B)|(0<<OCIE3A)|(1<<TOIE3)
	STS TIMSK3,temp
	; OCR3AH and OCR3AL  Output Compare Register 3 A		
	ldi temp,HIGH(TIM3WERT)
	STS OCR3AH,temp
	ldi temp,LOW (TIM3WERT)
	STS OCR3AL,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Uhr																			
TIM3_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG		; Einlesen des SREG 					
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)	
;-------------------------------------------------------------------------------
	ldi temp,LOW (TIM3WERT)
	STS TCNT3L,temp
	ldi temp,HIGH (TIM3WERT)
	STS TCNT3H,temp
;-------------------------------------------------------------------------------
	LDS temp,(adr_ss_VT)
	inc temp
	STS(adr_ss_VT),temp
	cpi temp,10
	brlo TIM3_OVF_w
	STS(adr_ss_VT),NULL
	push temp1
	rcall UHR
	pop temp1
;-------------------------------------------------------------------------------
TIM3_OVF_w:
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)		
	out	SREG,TEMP		; Wiederherstellen von SREG				
	pop	TEMP			; Wiederherstellen von "TEMP"			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR_NULL:
	STS(adr_SS_VT),NULL
	STS(adr_ss),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung ab 01.01.2000 mit Schaltjahr										
; Version 06/2019																
;																				
UHR:
	LDS temp,(adr_ss)
	inc temp
	cpi temp,60
	brsh UHR_mm
	STS (adr_ss),temp
	ret	
;-------------------------------------------------------------------------------
UHR_mm:
	STS (adr_ss),NULL			; Null					
;-------------------------------------------------------------------------------
	LDS temp,(adr_TIMER_REC)	; Aufnahme Timer		
	tst temp
	breq UHR_mm_w
	dec temp
	STS(adr_TIMER_REC),temp
;-------------------------------------------------------------------------------
UHR_mm_w:
	LDS temp,(adr_TIMER_SPERRE)	; Aufnahme Sperrtimer	
	tst temp
	breq UHR_mm_w1
	dec temp
	STS(adr_TIMER_SPERRE),temp
;-------------------------------------------------------------------------------
UHR_mm_w1:
	LDS temp,(adr_mm)
	inc temp
	cpi temp,60
	brsh UHR_hh
	STS (adr_mm),temp
	ret	
;-------------------------------------------------------------------------------
UHR_hh:
	STS (adr_mm),NULL		; Null				

	LDS temp,(adr_hh)
	inc temp
	cpi temp,24
	brsh UHR_WOCHENTAG
	STS (adr_hh),temp
	ret	
;-------------------------------------------------------------------------------
; WOCHENTAG				
UHR_WOCHENTAG:	
	LDS temp,(adr_WOCHENTAG)
	inc temp
	cpi temp,7+1
	brlo UHR_WOCHENTAG_w
	ldi temp,1
UHR_WOCHENTAG_w:
	STS(adr_WOCHENTAG),temp
;-------------------------------------------------------------------------------
; TAG					
	STS (adr_hh),NULL	; Null	

	LDS temp,(adr_TAG)
	inc temp
	STS (adr_TAG),temp
	rcall UHR_MONATSTAGE_TEMP1	; Tage im Monat	
	cp temp,temp1 
	breq UHR_TAG_w
	brsh UHR_MONAT
UHR_TAG_w:
	ret
;-------------------------------------------------------------------------------
; MONAT					
UHR_MONAT:
	STS (adr_TAG),EINS	; EINS	
	LDS temp,(adr_MONAT)
	inc temp
	STS (adr_MONAT),temp
	cpi temp,13 
	brsh UHR_JAHR
	ret
;-------------------------------------------------------------------------------
; JAHR					
UHR_JAHR:
	STS (adr_MONAT),EINS	; MONAT=1			
	LDS temp,(adr_JAHR)		; JAHR+1			
	inc temp
	STS (adr_JAHR),temp
	ret
;-------------------------------------------------------------------------------
; Anzahl der TAGE im Monat	
UHR_MONATSTAGE_TEMP1:
	LDS temp1,(adr_MONAT)	; MONAT laden			
	; vergleich				
	cpi temp1,2			; Februar 28/29			
	breq UHR_FEBRUAR
	cpi temp1,4			; April 30				
	breq UHR_30
	cpi temp1,6			; Juni 30				
	breq UHR_30
	cpi temp1,9			; September 30			
	breq UHR_30
	cpi temp1,11		; November 30			
	breq UHR_30
;-------------------------------------------------------------------------------
UHR_31:
	ldi temp1,31		
	ret
;-------------------------------------------------------------------------------
UHR_30:
	ldi temp1,30		
	ret
;-------------------------------------------------------------------------------
UHR_FEBRUAR:
	LDS temp1,(adr_JAHR)	; Jahr laden					
	andi temp1,0b00000011	; 2016, 20, 24, 28, 32 usw.  ...
	tst temp1
	breq UHR_29
	ldi temp1,28
	ret
;-------------------------------------------------------------------------------
UHR_29:
	ldi temp1,29
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

