;												
; RADIO SI4735 AM/FM/RDS/SD-Card fr ATmega8	
; Bernhard.Erfurt@gmx.de						
; 07.2019										
;												
; DISPLAY EA-EDIP160W-7LWTP						
; 20x13 (160x104)								
;												
; LW/AM	(153279 KHz)							
; MW/AM	(5201710 kHz)							
; KW/AM	(2.321.85 MHz)							
; UKW/FM(64108 MHz)							
;												
; AVR-Studio 4									
;												

;												
; LED blinken:									
; ROT: 				Interrupt Error				
; ROT+GELB:			Watchdog Error				
; ROT+GELB+GRN:	Programm-Check Error		
;												

; ATmega1284P 									
.include "m1284pdef.inc"
.include "MACROS.asm"				; Macros		
; KONSTANTEN									
.equ TAKT							=22000000	; 22 MHz
.equ VERSION						=0x01		; Programmversion
; TWI											
.equ TWI_ADRESSE_RADIO				= 17
.equ TWI_ADRESSE_DISPLAY			= 111 		;DEh	
; PWM											
.equ PWM_NF							=OCR2A		; PWM NF				
.equ PWM_ZEIG						=OCR2B		; PWM Zeigerinstrument	
; MODUI											
.equ MODUS_AUS						= 0
.equ MODUS_LW						= 1
.equ MODUS_MW						= 2
.equ MODUS_KW						= 3
.equ MODUS_FM						= 4
; FEHLER-CODES									
.equ ERROR_SD_STATUS				= 0xC0
.equ ERROR_SD_READ					= 0xE0	; schwerer Fehler	
.equ ERROR_SD_READ_MULTIPLE			= 0xEF	; schwerer Fehler	
.equ ERROR_SD_WRITE0				= 0xF0	; schwerer Fehler	
.equ ERROR_SD_WRITE1				= 0xF1	; schwerer Fehler	
.equ ERROR_SD_WRITE2				= 0xF2	; schwerer Fehler	
.equ ERROR_SD_WRITE_MULTIPLE		= 0xEF	; schwerer Fehler

.equ ERROR_GRAFIC_TX				= 6		; Verbindungsfehler		
.equ ERROR_GRAFIC_RX				= 8

.equ ERROR_TWI_TWINT				= 100
.equ ERROR_TWI_MT_START				= 101
.equ ERROR_TWI_MT_DATA				= 102
.equ ERROR_TWI_MR_START				= 103
.equ ERROR_TWI_MR_SLA				= 104
.equ ERROR_TWI_MR_DATA				= 105
.equ ERROR_TWI_MR_DATAEND			= 106

.equ ERROR_INT_STATUS				= 60
; DISPLAY_PUFFER								
.equ PUFFER_DISPLAY_MAX				= 60		; s. Datenblatt



; LED-GRN										
.equ LED_GRUEN_PIN_NR		= 0
.equ LED_GRUEN_DDR			= DDRB
.equ LED_GRUEN_PORT			= PORTB
; LED-GELB										
.equ LED_GELB_PIN_NR		= 1
.equ LED_GELB_DDR			= DDRB
.equ LED_GELB_PORT			= PORTB
; LED-ROT										
.equ LED_ROT_PIN_NR			= 2
.equ LED_ROT_DDR			= DDRB
.equ LED_ROT_PORT			= PORTB
; LED-GRN2											
.equ LED_GRUEN2_PIN_NR		= 1
.equ LED_GRUEN2_DDR			= DDRA
.equ LED_GRUEN2_PORT		= PORTA
; LED-GELB2										
.equ LED_GELB2_PIN_NR		= 2
.equ LED_GELB2_DDR			= DDRA
.equ LED_GELB2_PORT			= PORTA
; LED-ROT2										
.equ LED_ROT2_PIN_NR		= 3
.equ LED_ROT2_DDR			= DDRA
.equ LED_ROT2_PORT			= PORTA
; LED-STEREO									
.equ LED_STEREO_PIN_NR		= 4
.equ LED_STEREO_DDR			= DDRA
.equ LED_STEREO_PORT		= PORTA
; BEEP											
.equ BEEP_PIN_NR			= 7
.equ BEEP_DDR				= DDRA
.equ BEEP_PORT				= PORTA
; TFT											
.equ TFT_PIN_NR				= 7
.equ TFT_PIN				= PINC
.equ TFT_DDR				= DDRC
.equ TFT_PORT				= PORTC






; REGISTER										
.def ERROR		= R7
.def PWMI		= R8

.def SEKTOR0	= R9
.def SEKTOR1	= R10
.def SEKTOR2	= R11
.def SEKTOR3	= R12

.def NULL 		= R13
.def EINS 		= R14
.def VOLL		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25


; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)					
.equ adr_DATEN						=SRAM_START+0		; 0x0100 START Adresse 		
.equ adr_VERSION					=SRAM_START+0		; VERSION
.equ adr_SENDER_TASTE200			=SRAM_START+10		; 8Name,1Modus,2Frequenz,9Reserve	


.equ adr_PROGRAMM_VERKEHRSDURCHSAGE	=SRAM_START+300
.equ adr_PROGRAMM_TIMER				=SRAM_START+320

.equ adr_ss_VT						=SRAM_START+500		; Vorteiler					
.equ adr_ss							=SRAM_START+501		; Sekunden					
.equ adr_mm							=SRAM_START+502		; Minuten					
.equ adr_hh							=SRAM_START+503		; Stunden					
.equ adr_TAG						=SRAM_START+504		; TAG						
.equ adr_WOCHENTAG					=SRAM_START+505		; Wochentag (1=Mo 7=So)		
.equ adr_MONAT						=SRAM_START+506		; Monat						
.equ adr_JAHR						=SRAM_START+507		; JAHR						
.equ adr_TIMER_REC					=SRAM_START+508		; Timer-Aufnahme (Minuten)	
.equ adr_TIMER_SPERRE				=SRAM_START+509		; Aufnahme Sperre(Minuten)	

.equ adr_MENUE						=SRAM_START+510
.equ adr_TASTE						=SRAM_START+511
.equ adr_PROGRAMIERMODUS			=SRAM_START+512
.equ adr_EDIT_L						=SRAM_START+513
.equ adr_EDIT_H						=SRAM_START+514

.equ adr_REC_NR						=SRAM_START+640		; Audio-REC-NR				
.equ adr_REC_MODUS					=SRAM_START+641		; man=1 TIMER=2 TP= 3		

.equ adr_REC_STARTSEKTOR0			=SRAM_START+650
.equ adr_REC_STARTSEKTOR1			=SRAM_START+651
.equ adr_REC_STARTSEKTOR2			=SRAM_START+652
.equ adr_REC_STARTSEKTOR3			=SRAM_START+653

.equ adr_REC_ENDESEKTOR0			=SRAM_START+654
.equ adr_REC_ENDESEKTOR1			=SRAM_START+655
.equ adr_REC_ENDESEKTOR2			=SRAM_START+656
.equ adr_REC_ENDESEKTOR3			=SRAM_START+657

.equ adr_EINGABE_ZAHL_BYTE0			=SRAM_START+670		; Zahlenfeld	
.equ adr_EINGABE_ZAHL_BYTE1			=SRAM_START+671
.equ adr_EINGABE_ZAHL_BYTE2			=SRAM_START+672
.equ adr_EINGABE_ZAHL_BYTE3			=SRAM_START+673

.equ adr_EINGABE_ZAHLESC_BYTE0		=SRAM_START+674		; Zahlenfeld	
.equ adr_EINGABE_ZAHLESC_BYTE1		=SRAM_START+675
.equ adr_EINGABE_ZAHLESC_BYTE2		=SRAM_START+676
.equ adr_EINGABE_ZAHLESC_BYTE3		=SRAM_START+677


.equ adr_ZUFALLSZAHL				=SRAM_START+680
.equ adr_DUMMY						=SRAM_START+681		; DUMMY				
.equ adr_DUMMY0						=SRAM_START+682		; DUMMY				
.equ adr_DUMMY1						=SRAM_START+683
.equ adr_DUMMY2						=SRAM_START+684
.equ adr_DUMMY3						=SRAM_START+685

.equ adr_ZAEHLER0					=SRAM_START+696
.equ adr_ZAEHLER1					=SRAM_START+697
.equ adr_ZAEHLER2					=SRAM_START+698
.equ adr_ZAEHLER3					=SRAM_START+699

.equ adr_SD_PNM1					=SRAM_START+750		; Product name PNM				
.equ adr_SD_PNM2					=SRAM_START+751
.equ adr_SD_PNM3					=SRAM_START+752
.equ adr_SD_PNM4					=SRAM_START+753
.equ adr_SD_PNM5					=SRAM_START+754
.equ adr_SD_MDT_L					=SRAM_START+755		; Manufacturing date
.equ adr_SD_MDT_H					=SRAM_START+756
.equ adr_SD_PSN0					=SRAM_START+757		; Product serial number			
.equ adr_SD_PSN1					=SRAM_START+758
.equ adr_SD_PSN2					=SRAM_START+759
.equ adr_SD_PSN3					=SRAM_START+760

.equ adr_SD_SEKTOR_MAX0				=SRAM_START+800		; Secector max		
.equ adr_SD_SEKTOR_MAX1				=SRAM_START+801		; Secector max		
.equ adr_SD_SEKTOR_MAX2				=SRAM_START+802		; Secector max		
.equ adr_SD_SEKTOR_MAX3				=SRAM_START+803		; Secector max		

.equ adr_SD_CAPACITY_MB0			=SRAM_START+804		; Capacity in MB	
.equ adr_SD_CAPACITY_MB1			=SRAM_START+805		; Capacity in MB	
.equ adr_SD_CAPACITY_MB2			=SRAM_START+806		; Capacity in MB	
.equ adr_SD_CAPACITY_MB3			=SRAM_START+807		; Capacity in MB	

.equ adr_SD_SDHC_AKTIV				=SRAM_START+910		; 0=SDSC 1=SDHC		
.equ adr_SD_CSD_READ_BL_LEN			=SRAM_START+911 	; Register CSD =>READ_BL_LEN	
.equ adr_SD_CSD_C_SIZE_0			=SRAM_START+912		; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_1			=SRAM_START+913		; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_MULT			=SRAM_START+914 	; Register CSD =>C_SIZE_MULT	
.equ adr_SD_CSD_MULT_L				=SRAM_START+915
.equ adr_SD_CSD_MULT_H				=SRAM_START+916

.equ adr_SD_DATA					=SRAM_START+1000	; SD-DATA					

.equ adr_TWI_BEREICH_READ			=SRAM_START+2000	; BEREICH fr Master TWI/I2C


.equ adr_MODUS_AM_FM				=SRAM_START+3000	; LW=1 MW=2 KW=3 UKW=4		
.equ adr_MODUS_AM_FM_OLD			=SRAM_START+3001
.equ adr_MODUS_AM_FM_NEW			=SRAM_START+3002
.equ adr_TUNE_FREQUENZ_L			=SRAM_START+3003 	; Frequenz LOW				
.equ adr_TUNE_FREQUENZ_H			=SRAM_START+3004 	; Frequenz HIGH				
.equ adr_TUNE_FREQUENZ_OLD_L		=SRAM_START+3005 	
.equ adr_TUNE_FREQUENZ_OLD_H		=SRAM_START+3006 	
.equ adr_TUNE_FREQUENZ_NEW_L		=SRAM_START+3007 	
.equ adr_TUNE_FREQUENZ_NEW_H		=SRAM_START+3008 	
.equ adr_DAUER						=SRAM_START+3009	; Zeit in mm				

.equ adr_SENDERNAME8				=SRAM_START+3010	; 8 BYTES	fr Sendername oder Frequenz	
.equ adr_VOLUME						=SRAM_START+3020 	; Lautstrke						

.equ adr_STATUS						=SRAM_START+3040	; SI4753 STATUS					
.equ adr_PILOT						=SRAM_START+3041 	; Pilot Indicator 0=Mono 1=Stereo					
.equ adr_STBLEND					=SRAM_START+3042  	; Stereo Blend Indicator. Indicates amount of stereo blend in% (100 = full stereo, 0 = full mono).
.equ adr_RSSI   					=SRAM_START+3043 	; Received Signal Strength Indicator. Contains the current receive signal strength (0127 dBV).				
.equ adr_SNR    					=SRAM_START+3044	; SNR. Contains the current SNR metric (0127 dB).	
.equ adr_MULT						=SRAM_START+3045	; Multipath						

.equ adr_RDS_BLOCK_AH				=SRAM_START+3060	; RDS BLOCK-A		
.equ adr_RDS_BLOCK_AL				=SRAM_START+3061
.equ adr_RDS_BLOCK_BH				=SRAM_START+3062	; RDS BLOCK-B		
.equ adr_RDS_BLOCK_BL				=SRAM_START+3063
.equ adr_RDS_BLOCK_CH				=SRAM_START+3064	; RDS BLOCK-C		
.equ adr_RDS_BLOCK_CL				=SRAM_START+3065
.equ adr_RDS_BLOCK_DH				=SRAM_START+3066	; RDS BLOCK-D		
.equ adr_RDS_BLOCK_DL				=SRAM_START+3067

.equ adr_RDS_FIFO					=SRAM_START+3070	; FIFO max 25								
.equ adr_RDS_PI_L					=SRAM_START+3071	; PI										
.equ adr_RDS_PI_H					=SRAM_START+3072	; PI										
.equ adr_RDS_GT						=SRAM_START+3073	; Gruppentyp								
.equ adr_RDS_PTY					=SRAM_START+3074 	; PTY										
.equ adr_RDS_TP						=SRAM_START+3075	; Traffic Programm 		(Verkehsfunk)		
.equ adr_RDS_TA						=SRAM_START+3076 	; Traffic Announcement 	(Verkehrsdurchsage)	
.equ adr_RDS_MS						=SRAM_START+3077 	; Musik / Sprache	(0=Sprache 1=Musik)		
.equ adr_RDS_ERROR					=SRAM_START+3078	; RDS-Error									
.equ adr_RDS_ZEIT_HH				=SRAM_START+3079	; RDS-ZEIT									
.equ adr_RDS_ZEIT_MM				=SRAM_START+3080 	; RDS-ZEIT									
.equ adr_RDS_ZEIT_OFFSET			=SRAM_START+3081 	; RDS-ZEIT (Offset)							
.equ adr_RDS_DATUM0					=SRAM_START+3082	; Modified Julian Day Code 					
.equ adr_RDS_DATUM1					=SRAM_START+3083	; Modified Julian Day Code 					
.equ adr_RDS_DATUM2					=SRAM_START+3084
.equ adr_RDS_TAG					=SRAM_START+3085 	;
.equ adr_RDS_MONAT					=SRAM_START+3086 	;
.equ adr_RDS_JAHR					=SRAM_START+3087 	;


.equ adr_RDS_AF_ZEIGER				=SRAM_START+3088 	; Zeiger fr AF Darstellung					
.equ adr_RDS_AF_ZEILE				=SRAM_START+3089 	; ZEILE fr AF Darstellung					



.equ adr_RDS_4A_AH					=SRAM_START+3090
.equ adr_RDS_4A_AL					=SRAM_START+3091
.equ adr_RDS_4A_BH					=SRAM_START+3092
.equ adr_RDS_4A_BL					=SRAM_START+3093
.equ adr_RDS_4A_CH					=SRAM_START+3094
.equ adr_RDS_4A_CL					=SRAM_START+3095
.equ adr_RDS_4A_DH					=SRAM_START+3096
.equ adr_RDS_4A_DL					=SRAM_START+3097


.equ adr_RDS_SENDERNAME8			=SRAM_START+3100	;   8 Bytes fr Sendername					

.equ adr_RDS_BEREICH_GT32			=SRAM_START+3120	;  32 Bytes	fr empfangene Gruppennummern	

.equ adr_RDS_BEREICH_RADIOTEXT128	=SRAM_START+3200	; 128 Bytes	fr Radiotext					

.equ adr_RDS_BEREICH_AF205			=SRAM_START+3350	; 205 Bytes fr Alternativfrequenzen (0=87,5...204=107,9)	

.equ adr_GRAFIC_PUFFER_TX_ZEIGER	=SRAM_START+3800	; Zeiger Puffer						
.equ adr_GRAFIC_PUFFER256			=SRAM_START+3801	; Puffer

.equ adr_SRAM_CHECK					=SRAM_START+16300	; SRAM CHECK muss immer "S" sein	



.cseg							;Beginn eines Code-Segmentes
.org 0							;Startadresse=0				
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 jmp WDT 			 ; Watchdog Timeout			
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA			
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF 	; Timer1 Overflow		
.org 0x0020 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPA ; Timer0 CompareA			
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp ADCI 			 ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp TIM3_OVF 		 ; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	call wait_100ms
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
	sbi (LED_GELB_PORT)  ,(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)				; STACK initialisieren	
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	call SRAM_CLEAR						; SRAM_CLEAR			
	call PORT_CLEAR						; Ports auf EINGANG		
	call STARTWERTE						; Startwerte			
	call WDR_INITIALISIERUNG			; WDR					
	call LED_INITIALISIERUNG			; LED_INITIALISIERUNG	
	call TWI_INI						; TWI					
	call TFT_INITIALISIERUNG			; TFT					
	call TIMER2_INITIALISIERUNG_PWM8	; PWM NF/Analoginstrument
	call TIMER3_INITIALISIERUNG_UHR		; Uhr					
	call ADC_INITIALISIERUNG			; ADC					
	call SPI_INITIALISIERUNG			; SPI					
	call PROGRAMM_CHECK					; Check					
	sei									; Interrupts enable		
;-------------------------------------------------------------------------------
	call TFT_CLEAR
	call EEPROM_LOAD
	call TFT_CLEAR
	call SI4735_FM
	call AUDIO_ON
	call TFT_CLEAR
	call SD_INITIALISIERUNG
	call TFT_CLEAR
;-------------------------------------------------------------------------------
	ldi temp1,0
	call FAVORIT_LOAD_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	call SI4735_ABFRAGEN
	call GRAFIC_TASTEN_ABFRAGEN
	call MENUE
	call CALC_VERKEHRSDURCHSAGE
	call CALC_TIMER
	call SD_CHECK
	call PROGRAMM_CHECK					; Check					
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
CALC_VERKEHRSDURCHSAGE:
	LDS temp,(adr_RDS_TA)	; Verkehrsdurchsage	
	tst temp
	brne CALC_VERKEHRSDURCHSAGE_w
	ret
;-------------------------------------------------------------------------------
CALC_VERKEHRSDURCHSAGE_w:
	ldi ZL,low (adr_PROGRAMM_VERKEHRSDURCHSAGE)
	ldi ZH,high(adr_PROGRAMM_VERKEHRSDURCHSAGE)	
	rcall CALC_PROG_Z_C
	brcs CALC_VERKEHRSDURCHSAGE_RUN
	ret
;-------------------------------------------------------------------------------
CALC_VERKEHRSDURCHSAGE_RUN:
	LDS temp,(adr_TIMER_SPERRE)	; Aufnahme Sperrtimer	
	tst temp
	breq CALC_VERKEHRSDURCHSAGE_RUNw
	ret
;-------------------------------------------------------------------------------
CALC_VERKEHRSDURCHSAGE_RUNw:
	ldi temp,10
	STS(adr_TIMER_SPERRE),temp	; Aufnahme Sperrtimer	

	ldi temp,2					; Dauer in mm	
	STS(adr_TIMER_REC),temp
	ldi temp,(REC_TP)			; Modus			
	STS(adr_REC_MODUS),temp
	call AUDIO_REC				; Record		
	jmp MENUE_26_FM_INI
; ##############################################################################
; ##############################################################################
; ##############################################################################
CALC_TIMER:
	ldi ZL,low (adr_PROGRAMM_TIMER+20*0)
	ldi ZH,high(adr_PROGRAMM_TIMER+20*0)
	rcall CALC_PROG_Z_C
	brcs CALC_TIMER_RUN
	ldi ZL,low (adr_PROGRAMM_TIMER+20*1)
	ldi ZH,high(adr_PROGRAMM_TIMER+20*1)
	rcall CALC_PROG_Z_C
	brcs CALC_TIMER_RUN
	ldi ZL,low (adr_PROGRAMM_TIMER+20*2)
	ldi ZH,high(adr_PROGRAMM_TIMER+20*2)
	rcall CALC_PROG_Z_C
	brcs CALC_TIMER_RUN
	ldi ZL,low (adr_PROGRAMM_TIMER+20*3)
	ldi ZH,high(adr_PROGRAMM_TIMER+20*3)
	rcall CALC_PROG_Z_C
	brcs CALC_TIMER_RUN
	ret
;-------------------------------------------------------------------------------
CALC_TIMER_RUN:
	LDS temp,(adr_TIMER_SPERRE)	; Aufnahme Sperrtimer	
	tst temp
	breq CALC_TIMER_RUNw
	ret
;-------------------------------------------------------------------------------
CALC_TIMER_RUNw:
	ldi temp,10
	STS(adr_TIMER_SPERRE),temp			; Aufnahme Sperrtimer	

	LDS temp1,(adr_TUNE_FREQUENZ_L)		; aktuell				
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	STS(adr_TUNE_FREQUENZ_OLD_L),temp1	; save					
	STS(adr_TUNE_FREQUENZ_OLD_H),temp2

	LDS temp1,(adr_TUNE_FREQUENZ_NEW_L)	; neu					
	LDS temp2,(adr_TUNE_FREQUENZ_NEW_H)
	call SI4735_FM_TUNE_FREQ_TEMP1_2



	LDS temp,(adr_DAUER)				; Dauer in mm			
	STS(adr_TIMER_REC),temp

	ldi temp,(REC_TIMER)				; Modus					
	STS(adr_REC_MODUS),temp

	call AUDIO_REC						; Record				

	LDS temp1,(adr_TUNE_FREQUENZ_OLD_L)	; alter Sender wieder einstellen
	LDS temp2,(adr_TUNE_FREQUENZ_OLD_H)
	call SI4735_FM_TUNE_FREQ_TEMP1_2
	jmp MENUE_26_FM_INI
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 00: Mo																		
; 01: Di																		
; 02: Mi																		
; 03: Do																		
; 04: Fr																		
; 05: Sa																		
; 06: So																		
; 07: ON/OFF																	
; 08: Anfang (Zeitzahl_L)														
; 09: Anfang (Zeitzahl_H)														
; 10: Dauer in mm																
; 11: Favorit																	
CALC_PROG_Z_C:
	STS(adr_DUMMY0),ZL		; Z save			
	STS(adr_DUMMY1),ZH
	LDS temp,(adr_WOCHENTAG); Uhr gestellt?		
	tst temp
	brne CALC_PROG_WT
	rjmp CALC_PROG_NO
;-------------------------------------------------------------------------------
; Wochentag																		
CALC_PROG_WT:
	LDS ZL,(adr_DUMMY0)		; Z			
	LDS ZH,(adr_DUMMY1)
	LDS temp,(adr_WOCHENTAG)
	dec temp	; -1
	add ZL,temp
	adc ZH,NULL
	LD temp,Z				; Wochentag	?
	tst temp
	brne CALC_PROG_ONOFF
	rjmp CALC_PROG_NO
;-------------------------------------------------------------------------------
; ON/OFF																		
CALC_PROG_ONOFF:
	LDS ZL,(adr_DUMMY0)		; Z			
	LDS ZH,(adr_DUMMY1)
	adiw ZL,7
	LD temp,Z				; ON/OFF	
	tst temp
	brne CALC_PROG_ANF
	rjmp CALC_PROG_NO
;-------------------------------------------------------------------------------
; Anfang																		
CALC_PROG_ANF:
	LDS temp,(adr_hh)
	ldi temp1,60
	mul temp,temp1
	LDS temp,(adr_mm)	
	add R0,temp
	adc R1,NULL
	LDS ZL,(adr_DUMMY0)		; Z			
	LDS ZH,(adr_DUMMY1)
	adiw ZL,8
	LD temp1,Z+			;Anfang 	
	LD temp2,Z+
	cp R1,temp2			; vergleich	
	brlo CALC_PROG_NO
	breq CALC_PROG_ANF_LOW
	brsh CALC_PROG_DAUER
CALC_PROG_ANF_LOW:
	cp R0,temp1
	brlo CALC_PROG_NO
	breq CALC_PROG_DAUER
	brsh CALC_PROG_DAUER
;-------------------------------------------------------------------------------
; Dauer																			
CALC_PROG_DAUER:
	LDS ZL,(adr_DUMMY0)	; Z			
	LDS ZH,(adr_DUMMY1)
	adiw ZL,10
	LD temp,Z			; Dauer			
	STS(adr_DAUER),temp ; Dauer save	
	add temp1,temp		; Anfang+Dauer	
	adc temp2,NULL
	cp R1,temp2			; vergleich	
	brlo CALC_PROG_w4
	breq CALC_PROG_DAUER_L
	brsh CALC_PROG_NO
CALC_PROG_DAUER_L:
	cp R0,temp1
	brlo CALC_PROG_w4
	breq CALC_PROG_NO
	brsh CALC_PROG_NO
;-------------------------------------------------------------------------------
; Favorit																		
CALC_PROG_w4:
	LDS ZL,(adr_DUMMY0)	; Z			
	LDS ZH,(adr_DUMMY1)
	adiw ZL,11
	LD temp1,Z			; Favorit
	ldi temp,20
	MUL temp,temp1
	ldi ZL,low (adr_SENDER_TASTE200)
	ldi ZH,high(adr_SENDER_TASTE200)
	add ZL,R0
	adc ZH,R1
	LD temp,Z+			; Name		
	LD temp,Z+			; Name		
	LD temp,Z+			; Name		
	LD temp,Z+			; Name		
	LD temp,Z+			; Name		
	LD temp,Z+			; Name		
	LD temp,Z+			; Name		
	LD temp,Z+			; Name		
	LD temp,Z+			; Modus		
	STS(adr_MODUS_AM_FM_NEW),temp
	LD temp,Z+			; Freuenz	
	STS(adr_TUNE_FREQUENZ_NEW_L),temp
	LD temp,Z+			; Freuenz	
	STS(adr_TUNE_FREQUENZ_NEW_H),temp
	rjmp CALC_PROG_OK
;-------------------------------------------------------------------------------
CALC_PROG_NO:
	CLC ;Clear Carry
ret
;-------------------------------------------------------------------------------
CALC_PROG_OK:
	SEC ;Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TIMER.asm"				; PWM			
.include "ADC.asm"					; ADC			
.include "AUDIO.asm"				; Sound			
.include "SPI.asm"					; SPI			
.include "SD.asm"					; SD			
.include "SD_SONSTIGES.asm"			; SD			
.include "SONSTIGES.asm"			; sonstiges		
.include "TWI.asm"					; TWI/I2C		

.include "MENUE.asm"				; Menue


.include "ANZEIGE.asm"				; ASCII			
.include "ANZEIGE_KURZ.asm"			; ASCII			

.include "SI4735.asm"
.include "SI4735_FM.asm"
.include "SI4735_RDS.asm"
.include "SI4735_AM.asm"

.include "TFT.asm"					; TFT			
.include "TASTEN.asm"				; TFT			
.include "TASTEN_DEF.asm"			; TFT			

.include "EEPROM.asm"				; EEPROM		
.include "TEXTE.asm"				; ASCII			
.include "WAIT.asm"					; wait			


;													
; TASTEN											
; X, Y, dX, dY, dowCod, TEXT, NULL					
;													
; 20x13 (160x104)									
TASTE_REC:
.db   0,20,159,80,(1),'@','R','e','c','o','r','d'	,0,0		; Record (DUMMY)
TASTE_VERSTECKT:
.db   0,20,159,80,(1),'M'			,0,0		; (versteckt)		
TASTE_VERSTECKT2:
.db   0,20,159,80,(2),'M'			,0,0		; (versteckt)		
; JA/NEIN													
TASTE_JA:
.db   10,60,50,16,(1),'j','a'		,0		; ja	
TASTE_NEIN:
.db   80,60,50,16,(2),'n','e','i','n',0		; nein	
;-------------------------------------------------------------------------------
; PLAY																			
TASTE_PA:
.db    0,0,30,16,(10),'<',' '	,0		;
TASTE_PB:
.db   30,0,30,16,(11),'<','<'	,0		;
TASTE_PC:
.db   60,0,30,16,(12),'E','S','C'	,0,0; ESC
TASTE_PD:
.db   90,0,30,16,(13),'>','>'	,0		;
TASTE_PE:
.db  120,0,30,16,(14),' ','>'	,0		;

TASTE_PF:
.db    0,25,30,16,(15),'<','<'	,0		;
TASTE_PG:
.db   30,25,30,16,(16),'<',' '	,0		;
TASTE_PH:
.db   60,25,30,16,(17),'-','-'	,0		;
TASTE_PI:
.db   90,25,30,16,(18),' ','>'	,0		;
TASTE_PJ:
.db  120,25,30,16,(19),'>','>'	,0		;
;-------------------------------------------------------------------------------
; TASTEN Mo Di Mi Do Fr Sa So													
TASTE_MO:
.db    0,25,22,16,(1),'M','o'	,0		;
TASTE_DI:
.db   22,25,22,16,(2),'D','i'	,0		;
TASTE_MI:
.db   44,25,22,16,(3),'M','i'	,0		;
TASTE_DO:
.db   66,25,22,16,(4),'D','o'	,0		;
TASTE_FR:
.db   88,25,22,16,(5),'F','r'	,0		;
TASTE_SA:
.db  110,25,22,16,(6),'S','a'	,0		;
TASTE_SO:
.db  132,25,22,16,(7),'S','o'	,0		;
;-------------------------------------------------------------------------------
; TASTEN Edit Timer																
TASTE_ET0:
.db    0,0,30,16,(8) ,'o','n'		 	,0;
TASTE_ET1:
.db   30,0,30,16,(9) ,'A','n','f'	  ,0,0;
TASTE_ET2:
.db   60,0,30,16,(10),'D','a','u'	  ,0,0;
TASTE_ET3:
.db   90,0,30,16,(11),'F','a','v'	  ,0,0;
TASTE_ET4:
.db  120,0,30,16,(12),'0','k'			,0;
;-------------------------------------------------------------------------------
; kleines Menue																	
TASTE_KA:
.db    0,0,30,16,(10),'<','<'	,0		;
TASTE_KB:
.db   30,0,30,16,(11),'<',' '	,0		;
TASTE_KC:
.db   60,0,30,16,(12),'E','S','C'	,0,0; ESC
TASTE_KD:
.db   90,0,30,16,(13),' ','>'	,0		;
TASTE_KE:
.db  120,0,30,16,(14),'>','>'	,0		;

;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Hauptmenue																	
TASTE_00:
.db    0, 75,40,16,(20),'L','W'			,0		; LW	
TASTE_01:
.db    40,75,40,16,(22),'M','W'			,0		; MW	
TASTE_02:
.db    80,75,40,16,(24),'K','W'			,0		; KW	
TASTE_03:
.db   120,75,40,16,(26),'U','K','W'	,0,0		; UKW	
;-------------------------------------------------------------------------------
TASTE_04:
.db    0, 50,40,16,(30),'R','e','c'		,0,0	; Rec	
TASTE_05:
.db    40,50,40,16,(32),' ',' '			,0		; 		
TASTE_06:
.db    80,50,40,16,(34),' ',' '			,0		; 		
TASTE_07:
.db   120,50,40,16,(36),'P','l','a','y'	,0		; Play	
;-------------------------------------------------------------------------------
TASTE_08:
.db    0, 25,40,16,(40),' ',' '			,0		; 	
TASTE_09:
.db    40,25,40,16,(42),' ',' '			,0		; 	
TASTE_010:
.db    80,25,40,16,(44),' ',' '			,0		;	
TASTE_011:
.db   120,25,40,16,(46),' ',' '			,0		; 	
;-------------------------------------------------------------------------------
TASTE_012:
.db    0,  0,40,16,(50),'S','y','s','t'	,0		; System
TASTE_013:
.db    40, 0,40,16,(52),'s','a','v','e'	,0		; save	
TASTE_014:
.db    80, 0,40,16,(54),' ',' '			,0		; 		
TASTE_015:
.db   120, 0,40,16,(56),'@','F','a','v','o'	,0,0; load	
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Systemmenue1																	
TASTE_10:
.db    0, 75,40,16,(60),'T','0'			,0		; 
TASTE_11:
.db    40,75,40,16,(61),'T','1'			,0		; 
TASTE_12:
.db    80,75,40,16,(62),'T','2'			,0		; 
TASTE_13:
.db   120,75,40,16,(63),'T','3'			,0		; 
;-------------------------------------------------------------------------------
TASTE_14:
.db    0, 50,40,16,(64),' ',' '			,0		; 
TASTE_15:
.db    40,50,40,16,(65),' ',' '			,0		; 
TASTE_16:
.db    80,50,40,16,(66),' ',' '			,0		; 
TASTE_17:
.db   120,50,40,16,(67),' ',' '			,0		; 
;-------------------------------------------------------------------------------
TASTE_18:
.db    0, 25,40,16,(68),'T','A'			,0		; 
TASTE_19:
.db    40,25,40,16,(69),' ',' '			,0		; 
TASTE_110:
.db    80,25,40,16,(70),' ',' '			,0		; 
TASTE_111:
.db   120,25,40,16,(71),' ',' '			,0		; 
;-------------------------------------------------------------------------------
TASTE_112:
.db    0,  0,40,16,(72),'S','y','s','t'	,0		; System
TASTE_113:
.db    40, 0,40,16,(73),'H','e','l','l'	,0		; 
TASTE_114:
.db    80, 0,40,16,(74),' ',' '			,0		; 
TASTE_115:
.db   120, 0,40,16,(75),'E','S','C'		,0,0	; 
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Systemmenue2																	
TASTE_20:
.db    0, 75,40,16,(80),'S','D'			,0		; 
TASTE_21:
.db    40,75,40,16,(81),'f','o','r','m'	,0		; 
TASTE_22:
.db    80,75,40,16,(82),' ',' '			,0		; 
TASTE_23:
.db   120,75,40,16,(83),' ',' '			,0		; 
;-------------------------------------------------------------------------------
TASTE_24:
.db    0, 50,40,16,(84),'F','M'			,0		; 
TASTE_25:
.db    40,50,40,16,(85),'A','F'			,0		; 
TASTE_26:
.db    80,50,40,16,(86),'G','T'			,0		; 
TASTE_27:
.db   120,50,40,16,(87),' ',' '			,0		; 
;-------------------------------------------------------------------------------
TASTE_28:
.db    0, 25,40,16,(88),'D','a','t','e'	,0		; 
TASTE_29:
.db    40,25,40,16,(89),'T','i','m','e'	,0		; 
TASTE_210:
.db    80,25,40,16,(90),'T','a','g'		,0,0	; 
TASTE_211:
.db   120,25,40,16,(91),'I','n','f','o'	,0		; 
;-------------------------------------------------------------------------------
TASTE_212:
.db    0,  0,40,16,(92),'W','e','r','k'	,0		; 
TASTE_213:
.db    40, 0,40,16,(93),'R','e','s'		,0,0	; 
TASTE_214:
.db    80, 0,40,16,(94),'T','o','n'		,0,0	; 
TASTE_215:
.db   120, 0,40,16,(95),'E','S','C'		,0,0	; 
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; AM / FM																		
TASTE_SENDER_SEEK_DOWN:
.db    0,0,30,16,(100),'<','<'	,0		; SENDER <<			
TASTE_SENDER_STEP_DOWN:
.db   30,0,30,16,(101),'<',' '	,0		; SENDER <			
TASTE_SENDER_MANUELL:
.db   60,0,30,16,(102),'m'		,0,0	; SENDER (manuell)	
TASTE_SENDER_STEP_UP:
.db   90,0,30,16,(103),' ','>'	,0		; SENDER >			
TASTE_SENDER_SEEK_UP:
.db  120,0,30,16,(104),'>','>'	,0		; SENDER >>			
; Favoriten													
TASTE_F0:
.db    0, 75,80,16,(110),'-','-',0
TASTE_F1:
.db    80,75,80,16,(111),'-','-',0
TASTE_F2:
.db    0, 50,80,16,(112),'-','-',0
TASTE_F3:
.db    80,50,80,16,(113),'-','-',0
TASTE_F4:
.db    0, 25,80,16,(114),'-','-',0
TASTE_F5:
.db    80,25,80,16,(115),'-','-',0
TASTE_F6:
.db    0,  0,80,16,(116),'-','-',0
TASTE_F7:
.db    80, 0,80,16,(117),'-','-',0
; ZAHLENFELD												
; 1 2 3														
; 4 5 6														
; 7 8 9														
TASTE_1:	
.db  30,60,30,16, 101,'1'	,0,0		; "1"
TASTE_2:
.db  60,60,30,16, 102,'2'	,0,0		; "2"
TASTE_3:	
.db  90,60,30,16, 103,'3'	,0,0		; "3"
TASTE_4:	
.db  30,40,30,16, 104,'4'	,0,0		; "4"
TASTE_5:
.db  60,40,30,16, 105,'5'	,0,0		; "5"
TASTE_6:	
.db  90,40,30,16, 106,'6'	,0,0		; "6"
TASTE_7:	
.db  30,20,30,16, 107, '7'	,0,0		; "7"
TASTE_8:	
.db  60,20,30,16, 108, '8'	,0,0		; "8"
TASTE_9:	
.db  90,20,30,16, 109, '9'	,0,0		; "9"
TASTE_0:	
.db  60, 0,30,16, 100, '0'	,0,0		; "0"
TASTE_DEL:
.db 0, 40,30,16, 111, 'D','E','L',0,0	; "DEL"	
TASTE_ESC:
.db 0, 0,30,16, 112, 'E','s','c',0,0	; "ESC"	
TASTE_OK:
.db 120,0,30,16, 113, 'O','K',0			; "OK"	


; ##############################################################################
TEXT_BEGRUESSUNG_1:
.db "RADIO RDS SI4735 ",0
TEXT_BEGRUESSUNG_2:
.db "ATmega1284p - 22MHz",0
TEXT_BEGRUESSUNG_3:
.db "SD-Card",0
TEXT_BEGRUESSUNG_4:
.db "07/2019",0
; ##############################################################################
TEXT_PTY_00: 
.db "------------",0,0
TEXT_PTY_01: 
.db "Nachrichten",0 
TEXT_PTY_02: 
.db "Aktuelles",0 
TEXT_PTY_03: 
.db "Information",0 
TEXT_PTY_04: 
.db "Sport",0 
TEXT_PTY_05: 
.db "Bildung",0 
TEXT_PTY_06: 
.db "Hrspiel",0,0 
TEXT_PTY_07: 
.db "Kultur",0,0 
TEXT_PTY_08: 
.db "Wissenschaft",0,0 
TEXT_PTY_09: 
.db "Unterhaltung ",0 
TEXT_PTY_10: 
.db "Popmusik",0,0
TEXT_PTY_11: 
.db "Rockmusik",0 
TEXT_PTY_12: 
.db "Unterhaltungsmusik",0,0 
TEXT_PTY_13: 
.db "Leichte Klassik",0 
TEXT_PTY_14: 
.db "Ernste Klassik",0,0 
TEXT_PTY_15: 
.db "Andere Musik",0,0 
TEXT_PTY_16: 
.db "Wetter",0,0
TEXT_PTY_17: 
.db "Finanzen",0,0
TEXT_PTY_18: 
.db "Kinderprogramm",0,0
TEXT_PTY_19: 
.db "Gesellschaftliches",0,0
TEXT_PTY_20: 
.db "Religion",0,0
TEXT_PTY_21: 
.db "Telefonieren",0,0
TEXT_PTY_22: 
.db "Reisen",0,0
TEXT_PTY_23: 
.db "Freizeit",0,0
TEXT_PTY_24: 
.db "Jazzmusik",0
TEXT_PTY_25: 
.db "Countrymusik",0,0
TEXT_PTY_26: 
.db "Nationale Musik",0
TEXT_PTY_27: 
.db "Oldies",0,0
TEXT_PTY_28: 
.db "Volksmusik",0,0
TEXT_PTY_29: 
.db "Dokumentationen",0
TEXT_PTY_30: 
.db "Testalarm",0
TEXT_PTY_31: 
.db "Alarm",0

